
c       RTS:  2D VERSION
c       [x] WRITTEN
c       [x] COMPILES -Wall
c       [x] RUNS -fbounds-check
c       [x] CHECKS U=0
c           6x6 t=0.8 mu=-1.2 L=4 dtau=0.08333
c                 this code    nonint.e
c           rho   0.407448     0.407451
c            E   -0.196092    -0.195938
c       [ ] CHECKS t=0 Nsp=2
c       [x] CHECKS exact9bdp.f
c           6x6 lattice mu=0.0  dtau=0.125 U=4  L=16
c                     2D_SUN_debug_v4b.f     exact9bdp.f
c           density    1.0000 +- 0.0000    1.0000 +- 0.0000
c           Energy    -0.7379 +- 0.0013   -0.7365 +- 0.0011
c           Nud        0.1304 +- 0.0002    0.1303 +- 0.0002
c           C(0,1)    -0.1268             -0.1269 +- 0.0005
c           FOR 2D_SUN_debug_v4b C(0,1) = 2* (C11(0,1) - C12(0,1) )
c           C11(0,1)   0.2090 +- 0.0009
c           C12(0,1)   0.2724 +- 0.0002
c           6x6 lattice mu=0.0  dtau=0.125 U=4  L=32
c                     2D_SUN_debug_v4b.f     exact9bdp.f
c           density    1.0000 +- 0.0000    1.0000 +- 0.0000
c           Energy    -0.8315 +- 0.0017   -0.8310 +- 0.0017
c           Nud        0.1258 +- 0.0003    0.1260 +- 0.0002
c           C(0,1)    -0.1884             -0.1874 +- 0.0050
c           FOR 2D_SUN_debug_v4b C(0,1) = 2* (C11(0,1) - C12(0,1) )
c           C11(0,1)   0.1928 +- 0.0012
c           C12(0,1)   0.2870 +- 0.0007

! 07/18/19 SU(N) code for the Fermi Hubbard model -- Try to fix energy and correlation
! For the sake of simplicity, I'll use the same labeling, names, etc... used in SU(2)
! Need to change sweep, sweep2 and swpslice for the newest ones :)
! They are in the folder Compiled subroutines.

        program threed5
        implicit none
        integer begin_clock,end_clock,rate_clock
        character*40 outname
        character*41 rstring,gstring
        integer nx,ny,nz,l,Nspecies,volume,toff
        parameter(nx=4,ny=4,nz=1,l=10,Nspecies=6)
        parameter(volume=nx*ny*nz*l,toff=nx*ny*nz)

!       Variable number of bins by Martin Ulmke.
        integer nbin
!       Read the HS-configuration if input parameter hubflag = .true.
        logical hubflag
        parameter(nbin=10)
        integer warms,sweeps,nwrap
        integer iran,numtry
        common/integers/warms,sweeps,nwrap, iran
        real*8 tx,u,mu,dtau,expmuch,expmuchi,gam,lambda,txdtau
        common/couple/tx,u,mu,dtau,expmuch,expmuchi,gam,lambda,txdtau
        real*8 ty,tydtau,tz,tzdtau
        common/couple2/ty,tydtau,tz,tzdtau
!       BEGIN ==================================================================
        real*8 hub(0:volume-1,Nspecies,Nspecies)
        real*8 v(0:volume-1,Nspecies)
        real*8 gmat_i(0:toff,0:toff)
c        real*8 gmat_i(0:toff,0:toff),gmat_j(0:toff,0:toff)
        real*8 v_i(0:volume-1)
c        real*8 v_i(0:volume-1),v_j(0:volume-1)
        real*8 mphase(0:toff-1)

        common/vectors/hub,v,mphase
!       END ====================================================================
        real*8 twopi
        parameter(twopi=6.283185307179586d0)
        integer i,k,accept2,reject2,accept,reject,wraps,tausk
        parameter (tausk =200)
        integer j1,j2,j3,ti,mx,my,mz
        real*8 aveval,errval,aveval2,errval2
!       BEGIN ==================================================================
        real*8 sgn(Nspecies)
        real*8 n_species(Nspecies)
        real*8 sgntot
        real*8 nud(Nspecies,Nspecies)
        real*8 ke(Nspecies)
!       END ====================================================================

!       real*8 sgnup,sgndn,sgn,nup,ndn,nud,ke
        real*8 grfun(0:nx/2,0:ny/2,0:0)
        real*8 spinxx(0:nx/2,0:ny/2,0:0)
        real*8 spinzz(0:nx/2,0:ny/2,0:0)
        integer nmeas0,redo,noredo

!       BEGIN ==================================================================
        real*8 asgn_species(Nspecies),asgn,an(Nspecies)
        real*8 anud(Nspecies,Nspecies)
        real*8 ake(Nspecies)
!       END ====================================================================

!       real*8 asgnup,asgndn,asgn,anup,andn,anud,ake
        real*8 agrfun(0:nx/2,0:ny/2,0:0)
        real*8 aspinxx(0:nx/2,0:ny/2,0:0)
        real*8 aspinzz(0:nx/2,0:ny/2,0:0)
        real*8 den(0:nx/2,0:ny/2,0:0,0:1)
        real*8 aden(0:nx/2,0:ny/2,0:0,0:1)
        real*8 errrat

!       BEGIN ==================================================================
        real*8 spinab(0:nx/2,0:ny/2,0:0,Nspecies,Nspecies)
        real*8 aspinab(0:nx/2,0:ny/2,0:0,Nspecies,Nspecies)
!       END ====================================================================

        common/m0vects/ sgn,n_species,asgn_species,an,nud,ke,anud,ake

        common/m0var/ sgntot,
     1       grfun,spinxx,spinzz,aspinxx,aspinzz,
     2       asgn,den,aden,agrfun,errrat,spinab,aspinab

        common/m0vari/nmeas0,redo,noredo
        integer nmeast
        real*8 gnl(0:nx/2,0:ny/2,0:0,0:l)
        real*8 agnl(0:nx/2,0:ny/2,0:0,0:l),asgnt
        real*8 chinl(0:nx/2,0:ny/2,0:0,0:l)
        real*8 achinl(0:nx/2,0:ny/2,0:0,0:l)
        common/mtauvar/gnl,agnl,chinl,achinl,asgnt,nmeast

        real*8 gql(0:nx/2,0:ny/2,0:0,0:l)
        complex*16 gnw(0:nx/2,0:ny/2,0:0,0:l)
        complex*16 gqw(0:nx/2,0:ny/2,0:0,0:l)

        real*8 chiql(0:nx/2,0:ny/2,0:0,0:l)
        complex*16 chinw(0:nx/2,0:ny/2,0:0,0:l)
        complex*16 chiqw(0:nx/2,0:ny/2,0:0,0:l)

        complex*16 sigma(0:nx/2,0:ny/2,0:0,0:l)

        real*8 bgnl(0:nx/2,0:ny/2,0:0,0:l)
        real*8 bgql(0:nx/2,0:ny/2,0:0,0:l)
        complex*16 bgnw(0:nx/2,0:ny/2,0:0,0:l)
        complex*16 bgqw(0:nx/2,0:ny/2,0:0,0:l)

        real*8     bchinl(0:nx/2,0:ny/2,0:0,0:l)
        real*8     bchiql(0:nx/2,0:ny/2,0:0,0:l)
        complex*16 bchinw(0:nx/2,0:ny/2,0:0,0:l)
        complex*16 bchiqw(0:nx/2,0:ny/2,0:0,0:l)

        complex*16 bsigma(0:nx/2,0:ny/2,0:0,0:l)

        real*8 sgnl(0:nx/2,0:ny/2,0:0,0:l)
        real*8 sgql(0:nx/2,0:ny/2,0:0,0:l)
        complex*16 sgnw(0:nx/2,0:ny/2,0:0,0:l)
        complex*16 sgqw(0:nx/2,0:ny/2,0:0,0:l)

        real*8 schinl(0:nx/2,0:ny/2,0:0,0:l)
        real*8 schiql(0:nx/2,0:ny/2,0:0,0:l)
        complex*16 schinw(0:nx/2,0:ny/2,0:0,0:l)
        complex*16 schiqw(0:nx/2,0:ny/2,0:0,0:l)

        complex*16 ssigma(0:nx/2,0:ny/2,0:0,0:l)

!       variable number of bins
!       BEGIN ==================================================================
        real*8 bsgn_species(nbin,Nspecies)
        real*8 bsgn(nbin)
        real*8 bn(nbin,Nspecies)
        real*8 bntot(nbin),bnud(nbin,Nspecies,Nspecies)
        real*8 bke(nbin,Nspecies)
        real*8 benergy(nbin)
!       real*8 bsgnup(nbin)
!       real*8 bsgndn(nbin),bsgn(nbin),bnup(nbin),bndn(nbin)
!       real*8 bntot(nbin),bnud(nbin),bke(nbin),benergy(nbin)
!       END ====================================================================

        real*8 bgrfun(nbin,0:nx/2,0:ny/2,0:0)
        real*8 bden(nbin,0:nx/2,0:ny/2,0:0,0:1)
        real*8 bspinxx(nbin,0:nx/2,0:ny/2,0:0)
        real*8 bspinzz(nbin,0:nx/2,0:ny/2,0:0)
        real*8 bspinab(nbin,0:nx/2,0:ny/2,0:0,Nspecies,Nspecies)

!       BEGIN ==================================================================
        real*8 gmat(0:toff,0:toff,Nspecies)
        real*8 det(Nspecies),lndet(Nspecies)
        integer ispecies,jspecies
        real*8 epsk
        real*8 KEsave(Nspecies),KEsave0
        real*8 Dsave(Nspecies,Nspecies),Dsave0
        real*8 spinNNsaveAA,spinNNsaveAB,spinNNsave,sgnsave
!       END ====================================================================
!       real*8 gmatup(0:toff,0:toff),gmatdn(0:toff,0:toff),epsk
!		real*8 detup,detdn,lndetup,lndetdn
        integer nmax

c        real*8 nnspinxsave,nnspinzsave,rhosave
        real*8 rhosave
c        real*8 nnspinxPsave,nnspinzPsave

        if (nz.ne.1) then
             write (6,*) 'stopping:  this code only for nz=1'
             stop
        endif

        call system_clock(begin_clock,rate_clock)

        write (6,*) 'outname'
        read  (5,1789)  outname
1789    format(A40)

!       open output files
        rstring = 'r'//outname
        gstring = 'g'//outname
        open(unit=76, status='new',file=rstring)
        open(unit=78, status='new',file=gstring)

!       write header
        write(76,*) 'Version 2D_SUN_debug_v4a.f'
        write(76,*) ' '
        write(76,*) 'Nspecies=',Nspecies
        write(76,*) 'nx=',nx,'  ny=',ny
        write(76,*) 'nz=',nz,'   l=', l
        write(76,*) ' '
        write(76,*) 'nbin=',nbin
        write(76,*) ' '
        write(76,*) 'afeps = ',0.0

        write(78,*) 'Version 2D_SUN_debug_v4a.f'
        write(78,*) ' '
        write(78,*) 'nx=',nx,'  ny=',ny
        write(78,*) 'nz=',nz,'   l=', l
        write(78,*) ' '
        write(78,*) 'nbin=',nbin
        write(78,*) ' '
        write(78,*) 'afeps = ',0.0

!       set up the phase vectors
!       Do we really need this?
        call phaseset()

        call readin()

!       set up the index vectors

        call indexset()

        call ranlat()

        write (6,*) 'ENTER NUMTRY'
        read  (5,*)  numtry
        write (76,*) 'Using numtry = ',numtry
        write (78,*) 'Using numtry = ',numtry

!       input of the last HS-spin configuration on #76; 5/27/95 by Martin Ulmke
        read  (5,*)  hubflag
        write (6,*) 'ENTER HUBFLAG'
        if (HUBFLAG) then
            write(6,*)
            write(6,*) 'read HS-spin configuration:'
            write(6,*)
            do i=1,10
                read(5,*)
            enddo
            read(5,*) hub
        endif

!       I AM SKIPPING THE DEBUGGING SECTION THAT IS COMMENTED ON THE SU(2) CODE.

        nmax = l / 2
        accept = 0
        reject = 0
        accept2= 0
        reject2= 0
        do 141 ti = 0, l
            do 141 j1 = 0, nx/2
                do 141 j2 = 0, ny/2
                    do 141 j3 = 0, 0
                        bgnl(j1,j2,j3,ti) = 0.d0
                        bgnw(j1,j2,j3,ti) = 0.d0
                        bgql(j1,j2,j3,ti) = 0.d0
                        bgqw(j1,j2,j3,ti) = 0.d0
                        bchinl(j1,j2,j3,ti) = 0.d0
                        bchinw(j1,j2,j3,ti) = 0.d0
                        bchiql(j1,j2,j3,ti) = 0.d0
                        bchiqw(j1,j2,j3,ti) = 0.d0
                        bsigma(j1,j2,j3,ti) = 0.d0
                        sgnl(j1,j2,j3,ti) = 0.d0
                        sgnw(j1,j2,j3,ti) = 0.d0
                        sgql(j1,j2,j3,ti) = 0.d0
                        sgqw(j1,j2,j3,ti) = 0.d0
                        schinl(j1,j2,j3,ti) = 0.d0
                        schinw(j1,j2,j3,ti) = 0.d0
                        schiql(j1,j2,j3,ti) = 0.d0
                        schiqw(j1,j2,j3,ti) = 0.d0
                        ssigma(j1,j2,j3,ti) = 0.d0
141     continue

        call setvup()

!       Perform warmup sweeps
        wraps = nwrap
        redo = 0
        noredo = 0
!       BEGIN ==================================================================
!       In the SU(2) code getgp was called for gmatup and gmatdn.
        do ispecies=1,Nspecies
            call vshrink(v,v_i,ispecies)
            call getgp(v_i,0,gmat_i,sgn(ispecies),det(ispecies),
     1       lndet(ispecies))
            call vexpand(v,v_i,ispecies)
            call matexpand(gmat,gmat_i,ispecies)
        end do
!       NEED TO CHECK IF THE NEXT LINE SHOULD BE HERE
        do ispecies=1,Nspecies
            sgn(ispecies)=sgn(1)
        end do
        sgntot = PRODUCT(sgn)
!       END ====================================================================

        do 10 i=1,warms
            write(6,*)'Starting warmup sweep ',i
                call sweep(gmat,accept,reject,wraps)
                call sweep2(gmat,accept2,reject2,wraps,numtry)
10      continue
        write(76,*)'after warmups, accept ratio is ',
     1                float(accept)/(accept+reject)
        if (numtry.ne.0) then
            write(76,*)'after warmups, accept2 ratio is ',
     1               float(accept2)/(accept2+reject2)
        endif
        write(76,*)'gamma is ',gam
        write(76,*)'redo ratio is ',
     1                float(redo)/(redo+noredo)

!       Perform measurement sweeps
        call setvup()
        call zeroas()

        do 20 i=1,sweeps
            if(mod(i,10) .eq. 0) then
                write(6,*)'Starting measurement sweep ',i
                write(6,*)'accept, redo ratios are ',
     1                float(accept)/(accept+reject),
     2                float(redo)/(noredo+redo)
                if (numtry.ne.0) then
                    write(6,*)'accept2 ratio is ',
     1                  float(accept2)/(accept2+reject2)
                endif
            endif
            call sweep(gmat,accept,reject,wraps)
            call sweep2(gmat,accept2,reject2,wraps,numtry)

            if(mod(i,sweeps/nbin) .eq. 0) then
                write(76,*)'Finished measurement sweep ',i
                write(76,9045) asgn/nmeas0,
     1            float(accept)/(accept+reject),
     2            float(redo)/(noredo+redo)
9045            format('asgn: ',f8.3,
     1          ' accept,redo ratios: ',2('  ',f9.4))
                if (numtry.ne.0) then
                    write(76,*)'accept2 ratio is ',
     1                  float(accept2)/(accept2+reject2)
                endif
                k = (i*nbin)/sweeps
!       In the following lines, we have replaced nmeas0 with asgn
!       for a different error estimate.
                if(asgn .eq. 0.d0) then
                    write(76,*)'adding .01 to asgn'
                    asgn = asgn + .01d0
                endif
!       BEGIN ==================================================================
                do ispecies=1,Nspecies
                    bn(k,ispecies) = an(ispecies)/asgn
                    bke(k,ispecies) = ake(ispecies) / asgn
                    bsgn_species(k,ispecies) = asgn_species(ispecies)
     1               /nmeas0
                end do

                benergy(k) = 0.d0
                do ispecies=1,Nspecies
                    benergy(k) = benergy(k) + bke(k,ispecies)
                end do

                do ispecies=1,Nspecies-1
                    do jspecies = ispecies + 1, Nspecies
                        bnud(k,ispecies,jspecies) = anud(ispecies,
     1                   jspecies) / asgn
                        benergy(k)= benergy(k)+u*
     1                   bnud(k,ispecies,jspecies)
                    end do
                end do
                bntot(k) = SUM(an) / asgn
                bsgn(k) = asgn / nmeas0

!       END ====================================================================
                do 41 j1 = 0, nx/2
                    do 41 j2 = 0, ny/2
                        do 41 j3 = 0, 0
                            bgrfun(k,j1,j2,j3) = agrfun(j1,j2,j3) / asgn
                            bden(k,j1,j2,j3,0) = aden(j1,j2,j3,0) / asgn
                            bden(k,j1,j2,j3,1) = aden(j1,j2,j3,1) / asgn
                            bspinxx(k,j1,j2,j3) = aspinxx(j1,j2,j3)/asgn
                            bspinzz(k,j1,j2,j3) = aspinzz(j1,j2,j3)/asgn
                            do ispecies=1,Nspecies
                                do jspecies=1,Nspecies
                            bspinab(k,j1,j2,j3,ispecies,jspecies) =
     1                       aspinab(j1,j2,j3,ispecies,jspecies)/asgn
                                end do
                            end do
!       Set gnl and chinl for this tenth of the run.
                            do 41 ti = 0, l
                                gnl(j1,j2,j3,ti) = agnl(j1,j2,j3,ti)
     1                           /asgnt
                                gql(j1,j2,j3,ti) = 0.d0
                                chinl(j1,j2,j3,ti) = achinl(j1,j2,j3,ti)
     1                           /asgnt
                                chiql(j1,j2,j3,ti) = 0.d0
41              continue
                call ftntok(gnl,gql,nx,ny,nz,l)
                call ftntok(chinl,chiql,nx,ny,nz,l)
                call ftltow(gnl,gnw,nx,ny,nz,l,dtau,0,nmax)
                call ftltow(gql,gqw,nx,ny,nz,l,dtau,0,nmax)
                call ftltow(chinl,chinw,nx,ny,nz,l,dtau,1,nmax)
                call ftltow(chiql,chiqw,nx,ny,nz,l,dtau,1,nmax)

                do 586 mx = 0, nx/2
                    do 586 my = 0, ny/2
                        do 586 mz = 0, 0
                            do 586 ti = 0, l
                                bgnl(mx,my,mz,ti) = bgnl(mx,my,mz,ti) +
     1                              gnl(mx,my,mz,ti)
                                bgql(mx,my,mz,ti) = bgql(mx,my,mz,ti) +
     1                              gql(mx,my,mz,ti)
                                bchinl(mx,my,mz,ti)=bchinl(mx,my,mz,ti)+
     1                              chinl(mx,my,mz,ti)
                                bchiql(mx,my,mz,ti)=bchiql(mx,my,mz,ti)+
     1                              chiql(mx,my,mz,ti)
                                sgnl(mx,my,mz,ti) = sgnl(mx,my,mz,ti) +
     1                              gnl(mx,my,mz,ti)**2
                                sgql(mx,my,mz,ti) = sgql(mx,my,mz,ti) +
     1                              gql(mx,my,mz,ti)**2
                                schinl(mx,my,mz,ti)=schinl(mx,my,mz,ti)+
     1                              chinl(mx,my,mz,ti)**2
                                schiql(mx,my,mz,ti)=schiql(mx,my,mz,ti)+
     1                              chiql(mx,my,mz,ti)**2
                                if(ti .le. nmax)then
                                bgnw(mx,my,mz,ti) = bgnw(mx,my,mz,ti) +
     1                              gnw(mx,my,mz,ti)
                                bgqw(mx,my,mz,ti) = bgqw(mx,my,mz,ti) +
     1                              gqw(mx,my,mz,ti)
                                bchinw(mx,my,mz,ti)=bchinw(mx,my,mz,ti)+
     1                              chinw(mx,my,mz,ti)
                                bchiqw(mx,my,mz,ti)=bchiqw(mx,my,mz,ti)+
     1                              chiqw(mx,my,mz,ti)
                        sgnw(mx,my,mz,ti) = sgnw(mx,my,mz,ti) + cmplx(
     1                            dreal(gnw(mx,my,mz,ti))**2,
     1                           dimag(gnw(mx,my,mz,ti))**2)
                        sgqw(mx,my,mz,ti) = sgqw(mx,my,mz,ti) + cmplx(
     1                             dreal(gqw(mx,my,mz,ti))**2,
     1                            dimag(gqw(mx,my,mz,ti))**2)
                        schinw(mx,my,mz,ti) = schinw(mx,my,mz,ti) +
     1                          cmplx(dreal
     1                          (chinw(mx,my,mz,ti))**2,
     1                          dimag(chinw(mx,my,mz,ti))**2)
                        schiqw(mx,my,mz,ti) = schiqw(mx,my,mz,ti) +
     1                          cmplx(dreal
     1                          (chiqw(mx,my,mz,ti))**2,
     1                          dimag(chiqw(mx,my,mz,ti))**2)
                epsk = -2.d0*(tx*cos(twopi*mx/nx)+ty*cos(twopi*my/ny)+
     1                       tz*cos(twopi*mz/nz))
                sigma(mx,my,mz,ti)=cmplx(-epsk+mu,(ti+0.5d0)
     1                             *twopi/l/dtau)
     1                             + 1.d0/gqw(mx,my,mz,ti)
                bsigma(mx,my,mz,ti) = bsigma(mx,my,mz,ti) +
     1                                sigma(mx,my,mz,ti)
                ssigma(mx,my,mz,ti) = ssigma(mx,my,mz,ti) + cmplx(
     1                             dreal(sigma(mx,my,mz,ti))**2,
     1                            dimag(sigma(mx,my,mz,ti))**2)
                                endif
586             continue
                call zeroas()
            endif
20      continue

        write(76,*)'At end, redo ratio is ',float(redo)/(redo+noredo)
        write(76,*)'gamma is ',gam
        write(76,*)'Acceptance ratio = ',float(accept)/(accept+reject)
!       BEGIN ==================================================================
        KEsave0=0.d0
        do ispecies=1,Nspecies
            call geterr(bsgn_species(:,ispecies),aveval,errval)
            write(76,1112) ispecies,aveval,errval
            call geterr(bn(:,ispecies),aveval,errval)
            write(76,1113) ispecies,aveval,errval
            call geterr(bke(:,ispecies),aveval,errval)
            write(76,1114) ispecies,aveval,errval
            KEsave(ispecies) = aveval
            KEsave0=KEsave0+KEsave(ispecies) 
        end do
        KEsave0=KEsave0/dfloat(Nspecies)
1112    format('species: ',i3,'   sign: ',f10.6,' +- ',f10.6)
1113    format('species: ',i3,'   occ : ',f10.6,' +- ',f10.6)
1114    format('species: ',i3,'   KE  : ',f10.6,' +- ',f10.6)
1115    format(2i3,f10.6,' +- ',f10.6)
        Dsave0=0.d0
        write (76,*) '   a    b     <n(a)n(b)>  '
        do ispecies=1,Nspecies-1
            do jspecies=ispecies+1,Nspecies
                call geterr(bnud(:,ispecies,jspecies),aveval,errval)
                write(76,1115) ispecies,jspecies,aveval,errval
                Dsave(ispecies,jspecies)=aveval
                Dsave0=Dsave0+Dsave(ispecies,jspecies)
            end do
        end do
        Dsave0=2.d0*Dsave0/dfloat(Nspecies)/dfloat(Nspecies-1)
!       END ====================================================================
        call geterr(benergy,aveval,errval)
        write(76,*) 'Average Energy =',aveval,' +- ',errval
        call geterr(bsgn,aveval,errval)
        write(76,*) 'Average total sign =',aveval,' +- ',errval
        sgnsave=aveval
        call geterr(bntot,aveval,errval)
        write(76,*) 'Average density =',
     1         aveval,' +- ',errval
        rhosave=aveval

!       We are going to comment out the Green's function since we don't need it right now.
!        write(76,*)'Green''s function:'
!        do 677 j1 = 0, nx/2
!            do 677 j2 = 0, ny/2
!                do 677 j3 = 0, 0
!                    call geterr(bgrfun(1,j1,j2,j3),aveval,errval)
!                    write(76,1985)j1,j2,j3,aveval,errval
!                    grfun(j1,j2,j3) = aveval
!677     continue
!1985    format(3i4,'  ',f10.6,' +- ',f10.6)
!        write(76,*)'density-density correlation fn: (up-up,up-dn)'
!
!        do 977 j1 = 0, nx/2
!            do 977 j2 =  0, ny/2
!                do 977 j3 =  0, 0
!                    call geterr(bden(1,j1,j2,j3,0),aveval,errval)
!                    call geterr(bden(1,j1,j2,j3,1),aveval2,errval2)
!                    write(76,1987)j1,j2,j3,aveval,errval,aveval2,errval2
!1987                format(3i4,2('  ',f10.6,' +- ',f10.6))
!977     continue
!       BEGIN ==================================================================
1985    format(3i4,'  ',f10.6,' +- ',f10.6)
        
        spinNNsaveAA=0.d0
        spinNNsaveAB=0.d0
        write(76,*)'<na(i)nb(j)> Spin correlation function:'
        do ispecies=1,Nspecies
            do jspecies=1,Nspecies
                write(76,*) 'Correlation ','n',ispecies,'*','n',jspecies
                do 687 j1 = 0, nx/2
                    do 687 j2 =  0, ny/2
                        do 687 j3 =  0, 0
                    call geterr(bspinab(1,j1,j2,j3,ispecies,jspecies),
     1               aveval,errval)
                    write(76,1985)j1,j2,j3,aveval,errval

                    if (j1+j2+j3.eq.1) then
                        if (ispecies.eq.jspecies) then
                            spinNNsaveAA=spinNNsaveAA+aveval
                            else
                            spinNNsaveAB=spinNNsaveAB+aveval
                        endif
                    endif

687     continue
            end do
        end do
        spinNNsaveAA= spinNNsaveAA/dfloat(Nspecies)
        spinNNsaveAB= spinNNsaveAB/dfloat(Nspecies*(Nspecies-1))
        spinNNsaveAA= spinNNsaveAA/3.d0
        spinNNsaveAB= spinNNsaveAB/3.d0
        spinNNsave  = dfloat(Nspecies*(Nspecies-1))*
     1         (spinNNsaveAA-spinNNsaveAB)
        
!       END ====================================================================
!        write(76,*)'zz Spin correlation function:'
!        NNspinzsave=0.d0
!        NNspinzPsave=0.d0
!        do 688 j1 = 0, nx/2
!            do 688 j2 =  0, ny/2
!                do 688 j3 =  0, 0
!                    call geterr(bspinzz(1,j1,j2,j3),aveval,errval)
!                    write(76,1985)j1,j2,j3,aveval,errval
!       I dont fully understand the next 3 lines
!                    if (j1.eq.1.and.j2.eq.0.and.j3.eq.0)
!     c                NNspinzsave=NNspinzsave+aveval
!                    if (j1.eq.0.and.j2.eq.1.and.j3.eq.0)
!     c                NNspinzsave=NNspinzsave+aveval
!                    if (j1.eq.0.and.j2.eq.0.and.j3.eq.1)
!     c                NNspinzPsave=NNspinzPsave+aveval
!688     continue
!        write(76,*)'xx Spin correlation function:'
!        NNspinxsave=0.d0
!        NNspinxPsave=0.d0
!        do 697 j1 = 0, nx/2
!            do 697 j2 =  0, ny/2
!                do 697 j3 =  0, 0
!                    call geterr(bspinxx(1,j1,j2,j3),aveval,errval)
!                    write(76,1985)j1,j2,j3,aveval,errval
!                    if (j1.eq.1.and.j2.eq.0.and.j3.eq.0)
!     c                NNspinxsave=NNspinxsave+aveval
!                    if (j1.eq.0.and.j2.eq.1.and.j3.eq.0)
!     c                NNspinxsave=NNspinxsave+aveval
!                    if (j1.eq.0.and.j2.eq.0.and.j3.eq.1)
!     c                NNspinxPsave=NNspinxPsave+aveval
!697     continue

        call system_clock(end_clock)
        write(76,*)'elapsed time: ',real(end_clock -
     1   begin_clock)/real(rate_clock)

        open(unit=72, status='old',file='results.dat',access='append')
        write(72,8548) nspecies,nx,l,dtau,U,mu,rhosave,
     1       Dsave0,KEsave0,spinNNsave,sgnsave
8548    format(3i3,f8.4,f6.2,f8.3,5f8.4)
c8549    format(4f9.5)
        close(unit=72)

        write(78,*)'G(nx,ny,nz,ti):'
1234    format(i5,f14.6,' +- ',f14.6)
        do 987 j1 = 0, nx/2
            do 987 j2 =  0, ny/2
                do 987 j3 =  0, 0
                    write(78,*)j1,j2,j3
c1986                format('nx = ',i4,' ny = ',i4, ' nz= ',i4)
                    do 987 ti = 0,l
                        call geterr2(bgnl(j1,j2,j3,ti),
     1                      sgnl(j1,j2,j3,ti),aveval,errval)
                        write(78,1234)ti,-aveval,errval
987     continue

        write(78,*)'G(qx,qy,qz,ti):'
        do 9871 j1 = 0, nx/2
            do 9871 j2 =  0, ny/2
                do 9871 j3 =  0, 0
                    write(78,*)'qx = ',j1,' qy = ',j2,' qz = ',j3
                    do 9871 ti = 0,l
                        call geterr2(bgql(j1,j2,j3,ti),
     1                      sgql(j1,j2,j3,ti),aveval,errval)
                        write(78,1234)ti,-aveval,errval
9871    continue

        write(78,*)'G(nx,ny,nz,omega), omega = (n+.5) 2 pi T :'
        do 9872 j1 = 0, nx/2
            do 9872 j2 =  0, ny/2
                do 9872 j3 =  0, 0
                    write(78,*)'nx = ',j1,' ny = ',j2,' nz= ',j3
                    do 9872 ti = 0,nmax
                        call geterr2(dreal(bgnw(j1,j2,j3,ti)),
     1                  dreal(sgnw(j1,j2,j3,ti)),
     1                          aveval,errval)
                        call geterr2(dimag(bgnw(j1,j2,j3,ti)),
     1                      dimag(sgnw(j1,j2,j3,ti)),
     1                          aveval2,errval2)
                        write(78,1235)ti,-aveval,errval,-aveval2,errval2
1235                    format(i5,'(',f12.6,' +- ',f12.6,') + i * ('
     1                  ,f12.6,' +- ',f12.6,')')
9872    continue

        write(78,*)'G(qx,qy,qz,omega):'
        do 9873 j1 = 0, nx/2
            do 9873 j2 =  0, ny/2
                do 9873 j3 =  0, 0
                    write(78,*)'qx = ',j1,' qy = ',j2,' qz = ',j3
                    do 9873 ti = 0,nmax
                        call geterr2(dreal(bgqw(j1,j2,j3,ti)),
     1                  dreal(sgqw(j1,j2,j3,ti)),
     1                          aveval,errval)
                        call geterr2(dimag(bgqw(j1,j2,j3,ti)),
     1                      dimag(sgqw(j1,j2,j3,ti)),
     1                          aveval2,errval2)
                        write(78,1235)ti,-aveval,errval,-aveval2,errval2
9873    continue

        write(78,*)'chi(nx,ny,nz,ti):'
        do 417 j1 = 0, nx/2
            do 417 j2 = 0 , ny/2
                do 417 j3 = 0 , 0
                    write(78,*)'nx = ',j1,' ny = ',j2,' nz= ',j3
                    do 417 ti = 0,l
                call geterr2(bchinl(j1,j2,j3,ti),schinl(j1,j2,j3,ti),
     1           aveval,errval)
                write(78,1234)ti, aveval,errval
417     continue

        write(78,*)'chi(qx,qy,qz,ti):'
        do 4171 j1 = 0, nx/2
            do 4171 j2 = 0 , ny/2
                do 4171 j3 = 0 , 0
                    write(78,*)'qx = ',j1,' qy = ',j2,' qz= ',j3
                    do 4171 ti = 0,l
                call geterr2(bchiql(j1,j2,j3,ti),schiql(j1,j2,j3,ti),
     1           aveval,errval)
                write(78,1234)ti, aveval,errval
4171    continue

        write(78,*)'chi(nx,ny,nz,omega), omega = 2 n pi T :'
        do 4172 j1 = 0, nx/2
            do 4172 j2 = 0 , ny/2
                do 4172 j3 = 0 , 0
                    write(78,*)'nx = ',j1,' ny = ',j2,' nz= ',j3
                    do 4172 ti = 0,nmax
                call geterr2(dreal(bchinw(j1,j2,j3,ti)),
     1           dreal(schinw(j1,j2,j3,ti)),
     1                      aveval,errval)
                call geterr2(dimag(bchinw(j1,j2,j3,ti)),
     1           dimag(schinw(j1,j2,j3,ti)),
     1                      aveval2,errval2)
                write(78,1235)ti, aveval,errval,aveval2,errval2
4172    continue

        write(78,*)'chi(qx,qy,qz,omega):'
        do 4173 j1 = 0, nx/2
            do 4173 j2 = 0 , ny/2
                do 4173 j3 = 0 , 0
                    write(78,*)'qx = ',j1,' qy = ',j2,' qz= ',j3
                    do 4173 ti = 0,nmax
                call geterr2(dreal(bchiqw(j1,j2,j3,ti)),
     1           dreal(schiqw(j1,j2,j3,ti)),
     1                      aveval,errval)
                call geterr2(dimag(bchiqw(j1,j2,j3,ti)),
     1           dimag(schiqw(j1,j2,j3,ti)),
     1                      aveval2,errval2)
                write(78,1235)ti, aveval,errval,aveval2,errval2
4173    continue

        write(78,*)'SIGMA(qx,qy,qz,omega):'
        do 9874 j1 = 0, nx/2
            do 9874 j2 =  0, ny/2
                do 9874 j3 =  0, 0
                    write(78,*)'qx = ',j1,' qy = ',j2,' qz = '
                    do 9875 ti = nmax,0,-1
                call geterr2(dreal(bsigma(j1,j2,j3,ti)),
     1                  dreal(ssigma(j1,j2,j3,ti)),
     1                      aveval,errval)
                call geterr2(dimag(bsigma(j1,j2,j3,ti)),
     1                dimag(ssigma(j1,j2,j3,ti))
     1                      ,aveval2,errval2)
                write(78,1235)-(2*ti+1), aveval,errval,-aveval2,errval2
9875    continue
            do 9874 ti = 0,nmax
                call geterr2(dreal(bsigma(j1,j2,j3,ti)),
     1                  dreal(ssigma(j1,j2,j3,ti)),
     1                      aveval,errval)
                call geterr2(dimag(bsigma(j1,j2,j3,ti)),
     1                dimag(ssigma(j1,j2,j3,ti))
     1                      ,aveval2,errval2)
                write(78,1235)(2*ti+1), aveval,errval,aveval2,errval2
9874    continue

        stop
        end

! FUNCTIONS ARE FOR SHRINKING A MATRIX AND THEN EXPANDING IT.
! THESE FUNCTIONS WORK WITH THE *gbig* ARRAYS

! *****************************matshrink(Nspecies_array)***********
!     This subroutine extracts Greens function for given
!     species from *gbig* (Extra Nspecies Dimension) and puts it
!     into 'normal sized' *gsmall*

        subroutine matshrink(gbig,gsmall,ispecies)
        implicit none
        integer nx,ny,nz,l,Nspecies,volume,toff
        parameter(nx=4,ny=4,nz=1,l=10,Nspecies=6)
        parameter(volume=nx*ny*nz*l,toff=nx*ny*nz)
        real*8 gbig(0:toff,0:toff,Nspecies),gsmall(0:toff,0:toff)
        integer i,j,ispecies

        do i=0,toff-1
            do j=0,toff-1
                gsmall(i,j)=gbig(i,j,ispecies)
            enddo
        enddo

        return
        end

! *****************************vshrink(Nspecies_array)***********
!     This subroutine extracts interaction energy matrix for given
!     species from *vbig* (Extra Nspecies Dimension) and puts it
!     into 'normal sized' *vsmall*

        subroutine vshrink(vbig,vsmall,ispecies)
        implicit none
        integer nx,ny,nz,l,Nspecies,volume,toff
        parameter(nx=4,ny=4,nz=1,l=10,Nspecies=6)
        parameter(volume=nx*ny*nz*l,toff=nx*ny*nz)
        real*8 vbig(0:volume-1,Nspecies),vsmall(0:volume-1)
        integer i,ispecies

        do i=0,volume-1
            vsmall(i)=vbig(i,ispecies)
        enddo

        return
        end

! *****************************matexpand(Nspecies_array)***********
!     This subroutine writes a given species Greens function
!     in the 'normal sized' array *gsmall*
! 	  and puts it in *gbig*(Extra Nspecies Dimension)

        subroutine matexpand(gbig,gsmall,ispecies)
        implicit none
        integer nx,ny,nz,l,Nspecies,volume,toff
        parameter(nx=4,ny=4,nz=1,l=10,Nspecies=6)
        parameter(volume=nx*ny*nz*l,toff=nx*ny*nz)
        real*8 gbig(0:toff,0:toff,Nspecies),gsmall(0:toff,0:toff)
        integer i,j,ispecies

        do i=0,toff-1
            do j=0, toff-1
                gbig(i,j,ispecies) = gsmall(i,j)
            end do
        end do
        end


! *****************************vexpand(Nspecies_array)***********
!     This subroutine writes a given species interaction energy matrix
!     in the 'normal sized' array *vsmall*
! 	  and puts it in *vbig*(Extra Nspecies Dimension)

        subroutine vexpand(vbig,vsmall,ispecies)
        implicit none
        integer nx,ny,nz,l,Nspecies,volume,toff
        parameter(nx=4,ny=4,nz=1,l=10,Nspecies=6)
        parameter(volume=nx*ny*nz*l,toff=nx*ny*nz)
        real*8 vbig(0:volume-1,Nspecies),vsmall(0:volume-1)
        integer i,ispecies

        do i=0,volume-1
            vbig(i,ispecies) = vsmall(i)
        end do
        end

!*****************************setvup()*****************************

!       This subroutine sets v array given hubs.

        subroutine setvup()
        implicit none
        integer nx,ny,nz,l,Nspecies,volume,toff
        parameter(nx=4,ny=4,nz=1,l=10,Nspecies=6)
        parameter(volume=nx*ny*nz*l,toff=nx*ny*nz)

        real*8 tx,u,mu,dtau,expmuch,expmuchi,gam,lambda,txdtau
        common/couple/tx,u,mu,dtau,expmuch,expmuchi,gam,lambda,txdtau

        integer ispecies,jspecies,i

!       vectors:

        real*8 hub(0:volume-1,Nspecies,Nspecies)
        real*8 v(0:volume-1,Nspecies)
        real*8 mphase(0:toff-1)
        common/vectors/hub,v,mphase

        do i=0,volume-1
            do ispecies=1,Nspecies
               v(i,ispecies)=1.d0
               do jspecies=1,ispecies-1
                  v(i,ispecies)=v(i,ispecies)*
     1             dexp(-lambda*hub(i,jspecies,ispecies))
               enddo
               do jspecies=ispecies+1,Nspecies
                  v(i,ispecies)=v(i,ispecies)*
     1             dexp(+lambda*hub(i,ispecies,jspecies))
               enddo
            enddo
        enddo

        return
        end

! ******************************sweep2***************************
!		This subroutine relies on shrinking and expanding
!		We use sgntot instead of sgnn

        subroutine sweep2(gmat,accept,reject,wraps,numtry)
        implicit none
        integer nx,ny,nz,l,Nspecies,volume,toff
        parameter(nx=4,ny=4,nz=1,l=10,Nspecies=6)
        parameter(volume=nx*ny*nz*l,toff=nx*ny*nz)
        integer warms,sweeps,nwrap
        integer iran
        common/integers/warms,sweeps,nwrap, iran

!       BEGIN ==================================================================
        real*8 gmat(0:toff,0:toff,Nspecies)
        real*8 hub(0:volume-1,Nspecies,Nspecies)
        real*8 v(0:volume-1,Nspecies)
!       END ====================================================================
        real*8 mphase(0:toff-1)

!  	    common block for vectors
        common/vectors/hub,v,mphase

        integer accept,reject,wraps
        integer ti,numtry,isite,itry

!       BEGIN ==================================================================
        real*8 det(Nspecies),detp(Nspecies)
        real*8 sgn(Nspecies),sgnp(Nspecies)
        real*8 n_species(Nspecies)
        real*8 nud(Nspecies,Nspecies)
        real*8 ke(Nspecies)
        real*8 ranf,ran2
        real*8 lndet(Nspecies),lndetp(Nspecies)
        real*8 sgntot
!       END ====================================================================

!       BEGIN ==================================================================
        real*8 gmat_i(0:toff,0:toff),gmat_j(0:toff,0:toff)
        real*8 gmatp_i(0:toff,0:toff),gmatp_j(0:toff,0:toff)
        real*8 v_i(0:volume-1),v_j(0:volume-1)
        integer ispecies,jspecies
!       END ====================================================================

        real*8 grfun(0:nx/2,0:ny/2,0:0)
        real*8 spinxx(0:nx/2,0:ny/2,0:0)
        real*8 spinzz(0:nx/2,0:ny/2,0:0)
!       BEGIN ==================================================================
        real*8 asgn_species(Nspecies),asgn,an(Nspecies)
        real*8 anud(Nspecies,Nspecies)
        real*8 ake(Nspecies)
!       END ====================================================================
        real*8 agrfun(0:nx/2,0:ny/2,0:0)
        real*8 aspinxx(0:nx/2,0:ny/2,0:0)
        real*8 aspinzz(0:nx/2,0:ny/2,0:0)
        real*8 den(0:nx/2,0:ny/2,0:0,0:1)
        real*8 aden(0:nx/2,0:ny/2,0:0,0:1)
        real*8 errrat

!       BEGIN ==================================================================
        real*8 spinab(0:nx/2,0:ny/2,0:0,Nspecies,Nspecies)
        real*8 aspinab(0:nx/2,0:ny/2,0:0,Nspecies,Nspecies)
!       END ====================================================================

        common/m0var/ sgntot,
     1       grfun,spinxx,spinzz,aspinxx,aspinzz,asgn,
     2       den,aden,agrfun,errrat,spinab,aspinab

        common/m0vects/ sgn,n_species,asgn_species,an,nud,ke,anud,ake

!       BEGIN ==================================================================
!       doing i < j convention for the HS fields
        do ispecies =1,Nspecies-1
            do jspecies=ispecies+1,Nspecies
                call vshrink(v,v_i,ispecies)
                call vshrink(v,v_j,jspecies)

                call getgp(v_i,0,gmat_i,sgn(ispecies),det(ispecies),
     1           lndet(ispecies))
                call getgp(v_j,0,gmat_j,sgn(jspecies),det(jspecies),
     1           lndet(jspecies))
!               THE FOLLOWING DEFINITION IS NEW
                sgntot = PRODUCT(sgn)

                do 1000 itry=1,numtry
                    isite=int(ran2(iran)*toff)
                    do 100 ti=0,L-1
                        hub(isite+ti*toff,ispecies,jspecies)=-hub(isite+
     1                   ti*toff,ispecies,jspecies)
100                 continue

                    call setvup()
                    call vshrink(v,v_i,ispecies)
                    call vshrink(v,v_j,jspecies)
                    call getgp(v_i,0,gmatp_i,sgnp(ispecies),
     1               detp(ispecies),lndetp(ispecies))
                    call getgp(v_j,0,gmatp_j,sgnp(jspecies),
     1               detp(jspecies),lndetp(jspecies))
                    ranf=ran2(iran)

                    if (ranf.le.dexp(lndetp(ispecies)+lndetp(jspecies)-
     1               lndet(ispecies)-lndet(jspecies)) ) then
                        accept=accept+1
                        call matcop(gmatp_i,gmat_i)
                        call matcop(gmatp_j,gmat_j)
                        sgn(ispecies)=sgnp(ispecies)
                        sgn(jspecies)=sgnp(jspecies)
                        det(ispecies)=detp(ispecies)
                        det(jspecies)=detp(jspecies)
                        lndet(ispecies)=lndetp(ispecies)
                        lndet(jspecies)=lndetp(jspecies)

                        sgntot = PRODUCT(sgn)

                        call matexpand(gmat,gmatp_i,ispecies)
                        call matexpand(gmat,gmatp_j,jspecies)
                        call vexpand(v,v_i,ispecies)
                        call vexpand(v,v_j,jspecies)
                    else
                        do 200 ti=0,L-1
                            hub(isite+ti*toff,ispecies,jspecies)=
     1                       -hub(isite+ti*toff,ispecies,jspecies)
200                     continue
                        call setvup()
                        reject=reject+1
                    endif
1000            continue
            end do
        end do
!       END ====================================================================
        return
        end


! ****************************sweep*********************************
!		This subroutine is uses shrink and expand functions

        subroutine sweep(gmat,accept,reject,wraps)
        implicit none
        integer nx,ny,nz,l,Nspecies,volume,toff
        parameter(nx=4,ny=4,nz=1,l=10,Nspecies=6)
        parameter(volume=nx*ny*nz*l,toff=nx*ny*nz)
        integer warms,sweeps,nwrap
        integer iran
        common/integers/warms,sweeps,nwrap, iran
        integer orthlen,torth
        real*8 eorth,difflim,errpam
        common/getgpam/eorth,difflim,errpam,orthlen,
     1                torth
        save /getgpam/

        real*8 tx,u,mu,dtau,expmuch,expmuchi,gam,lambda,txdtau
        common/couple/tx,u,mu,dtau,expmuch,expmuchi,gam,lambda,txdtau

!       BEGIN ==================================================================
        real*8 gmat(0:toff,0:toff,Nspecies)
        real*8 hub(0:volume-1,Nspecies,Nspecies)
        real*8 v(0:volume-1,Nspecies)
c        real*8 ogmat(0:toff,0:toff),diff(Nspecies)
        real*8 ogmat(0:toff,0:toff)
        real*8 sgn(Nspecies),det(Nspecies),lndet(Nspecies)
        real*8 n_species(Nspecies)
        real*8 nud(Nspecies,Nspecies)
        real*8 ke(Nspecies)
        real*8 sgntot
!       END ====================================================================
        real*8 mphase(0:toff-1)

!  	    common block for vectors
        common/vectors/hub,v,mphase

        integer accept,reject,wraps
        integer ti,ti1

        real*8 accrat,redorat

!       BEGIN ==================================================================
        real*8 gmat_current(0:toff,0:toff)
        real*8 gmat_i(0:toff,0:toff),gmat_j(0:toff,0:toff)
        real*8 v_i(0:volume-1),v_j(0:volume-1),v_current(0:volume-1)
        integer ispecies,jspecies
        real*8 diff_current
!       END ====================================================================

        real*8 grfun(0:nx/2,0:ny/2,0:0)
        real*8 spinxx(0:nx/2,0:ny/2,0:0)
        real*8 spinzz(0:nx/2,0:ny/2,0:0)
        integer nmeas0,redo,noredo
!       BEGIN ==================================================================
        real*8 asgn_species(Nspecies),asgn,an(Nspecies)
        real*8 anud(Nspecies,Nspecies)
        real*8 ake(Nspecies)
!       END ====================================================================
        real*8 agrfun(0:nx/2,0:ny/2,0:0)
        real*8 aspinxx(0:nx/2,0:ny/2,0:0)
        real*8 aspinzz(0:nx/2,0:ny/2,0:0)
        real*8 den(0:nx/2,0:ny/2,0:0,0:1)
        real*8 aden(0:nx/2,0:ny/2,0:0,0:1)
        real*8 errrat

!       BEGIN ==================================================================
        real*8 spinab(0:nx/2,0:ny/2,0:0,Nspecies,Nspecies)
        real*8 aspinab(0:nx/2,0:ny/2,0:0,Nspecies,Nspecies)
!       END ====================================================================

        common/m0var/ sgntot,
     1       grfun,spinxx,spinzz,aspinxx,aspinzz,asgn,
     2       den,aden,agrfun,errrat,spinab,aspinab

        common/m0vects/ sgn,n_species,asgn_species,an,nud,ke,anud,ake

        common/m0vari/nmeas0,redo,noredo
        integer lastwr

        do ti = 0, l-1
!       BEGIN ====================================================================
!		We loop through the species and use multb on the shrinken versions and
!		then we expand them back.
            do ispecies=1,Nspecies
                call matshrink(gmat,gmat_current,ispecies)
                call vshrink(v,v_current,ispecies)
                call multb(gmat_current,v_current,ti,-1)
                call multbi(gmat_current,v_current,ti, 1)
                call matexpand(gmat,gmat_current,ispecies)
                call vexpand(v,v_current,ispecies)
            enddo
!       END =======================================================================
            if(wraps .gt. 0) then
                wraps = wraps - 1
            else
                wraps = nwrap
                ti1 = mod(ti+1,l)
!       BEGIN =====================================================================
!		matcop, getgp, matdif are 'normal size' arrays, so it seems like we need
!		another loop
                do ispecies=1,Nspecies
                    call matshrink(gmat,gmat_current,ispecies)
                    call vshrink(v,v_current,ispecies)
                    call matcop(gmat_current,ogmat)
                    call getgp(v_current,ti1,gmat_current,sgn(ispecies),
     1               det(ispecies),lndet(ispecies))
                    call matdif(gmat_current,ogmat,diff_current)
                    if(diff_current.gt.difflim)then
                        redo = redo+1
                    else
                        noredo=noredo+1
                    endif
                    call matexpand(gmat,gmat_current,ispecies)
                    call vexpand(v,v_current,ispecies)
                end do
            endif
!       END =======================================================================

!       BEGIN =====================================================================
            do ispecies=1,Nspecies-1
                do jspecies=ispecies+1,Nspecies
                    call matshrink(gmat,gmat_i,ispecies)
                    call vshrink(v,v_i,ispecies)
                    call matshrink(gmat,gmat_j,jspecies)
                    call vshrink(v,v_j,jspecies)

                    call swpslice(ispecies,jspecies,gmat_i,gmat_j,v_i,
     1               v_j,sgn(ispecies),sgn(jspecies),accept,reject,ti)

                    call matexpand(gmat,gmat_i,ispecies)
                    call vexpand(v,v_i,ispecies)
                    call matexpand(gmat,gmat_j,jspecies)
                    call vexpand(v,v_j,jspecies)
                end do
            end do
!       END =======================================================================

!       Now do the tau=0 measurements with the free of charge Green's functions.
!       Only do them every third time slice.

!       BEGIN =====================================================================
            if(mod(ti,12) .eq. 0) then
!                do ispecies=1,Nspecies
!                    call matshrink(gmat,gmat_current,ispecies)
                call meas0(gmat)
!                    call matexpand(gmat,gmat_current,ispecies)
!                end do
            end if
!       END =======================================================================
        end do

        if(accept+reject .gt. 10000) then
            accrat = dfloat(accept)/dfloat(accept+reject)
            if(accrat .gt. 0.52 .or. accrat .lt. 0.48)then
                gam = gam + (accrat - 0.5d0)
                gam = max(0.0,real(gam))
                gam = min(1.0,real(gam))
!               write(76,*)'accrat is ',accrat,' changing gam to ',gam
                accept = int(100.d0*accrat)
                reject = int(100.d0*(1.d0-accrat))
            endif
        endif

        if(redo .gt. 20) then
            redorat = dfloat(redo)/dfloat(redo+noredo)
            if(redorat.gt. errrat)then
                nwrap = nwrap - 1
                write(76,*)'reducing nwrap to ',nwrap
                redo = 0
                noredo = 1
            endif
        endif

        if(noredo .gt. 500) then
            redorat = dfloat(redo)/dfloat(redo+noredo)
            if(redorat .lt. 0.2d0*errrat) then
                if(nwrap .ge. lastwr)then
!       Only increase wrap if nwrap has not been reduced since last increase.
                nwrap = nwrap + 2
                write(76,*)'increasing nwrap to ',nwrap
                redo = 0
                noredo = 1
                lastwr = nwrap
                endif
            endif
        endif

        return
        end


! ****************************swpslice******************************

        subroutine swpslice(i,j,gmat_i,gmat_j,v_i,v_j,sgn_i,sgn_j,
     1       accept,reject,ti)
        implicit none
        integer nx,ny,nz,l,Nspecies,volume,toff
        parameter(nx=4,ny=4,nz=1,l=10,Nspecies=6)
        parameter(volume=nx*ny*nz*l,toff=nx*ny*nz)
        integer warms,sweeps,nwrap
        integer iran
        common/integers/warms,sweeps,nwrap, iran

        real*8 tx,u,mu,dtau,expmuch,expmuchi,gam,lambda,txdtau
        common/couple/tx,u,mu,dtau,expmuch,expmuchi,gam,lambda,txdtau

        real*8 hub(0:volume-1,Nspecies,Nspecies)
        real*8 v(0:volume-1,Nspecies)
        real*8 v_i(0:volume-1),v_j(0:volume-1)
        real*8 mphase(0:toff-1)

!       common block for vectors
        common/vectors/hub,v, mphase

        integer i,j
        integer accept,reject
        integer ti,nbar,nbari,j1,j2
        real*8 gmat_i(0:toff,0:toff),gmat_j(0:toff,0:toff)
        real*8 sgn_i,sgn_j
        real*8 bvec_i(0:toff-1),bvec_i2(0:toff-1)
        real*8 bvec_j(0:toff-1),bvec_j2(0:toff-1)
        real*8 vnbar_i,vnbar_j,rat_i,rat_j,rat,p,ran2,ranf

        do 20 nbar = 0, toff-1
            nbari = nbar + ti * toff
            vnbar_i = dexp(-2.d0*lambda*hub(nbari,i,j))
            vnbar_j = 1.d0 / vnbar_i - 1.d0
            vnbar_i = vnbar_i - 1.d0
            rat_i = 1.d0 + (1.d0 - gmat_i(nbar,nbar))*vnbar_i
            rat_j = 1.d0 + (1.d0 - gmat_j(nbar,nbar))*vnbar_j
            ranf=ran2(iran)
            rat = dabs(rat_i*rat_j)
            if(rat .le. 1.d0) p = rat/(1.d0+gam*rat)
            if(rat .gt. 1.d0) p = rat/(gam+rat)
            if(p .gt. ranf) then
                accept = accept + 1
                if(rat_i .lt. 0.d0)sgn_i = -sgn_i
                if(rat_j .lt. 0.d0)sgn_j = -sgn_j

                do 30 j1 = 0, toff-1
                    bvec_i(j1) = -vnbar_i*gmat_i(nbar,j1)
30                  bvec_j(j1) = -vnbar_j*gmat_j(nbar,j1)
                bvec_i(nbar) = bvec_i(nbar) + vnbar_i
                bvec_j(nbar) = bvec_j(nbar) + vnbar_j
                do 40 j1 = 0, toff-1
                    bvec_i2(j1) = gmat_i(j1,nbar)/(1.d0+bvec_i(nbar))
40                  bvec_j2(j1) = gmat_j(j1,nbar)/(1.d0+bvec_j(nbar))
                do 50 j1 = 0, toff-1
                    do 50 j2 = 0, toff-1
                      gmat_i(j1,j2)=gmat_i(j1,j2)-bvec_i2(j1)*bvec_i(j2)
50                    gmat_j(j1,j2)=gmat_j(j1,j2)-bvec_j2(j1)*bvec_j(j2)

            hub(nbari,i,j) = -hub(nbari,i,j)
            v_i(nbari) = v_i(nbari) * (vnbar_i+1.d0)
            v_j(nbari) = v_j(nbari) * (vnbar_j+1.d0)

          else
            reject = reject + 1
          endif
20      continue

        return
        end



! FUNCTIONS ARE FOR *gsmall* AND ARE INHERITED FROM THE SU(2) CODE.

!********* phaseset() - set and load phase vectors **********
        subroutine phaseset()
        implicit none
        integer nx,ny,nz,l,Nspecies,volume,toff
        parameter(nx=4,ny=4,nz=1,l=10,Nspecies=6)
        parameter(volume=nx*ny*nz*l,toff=nx*ny*nz)
        real*8 hub(0:volume-1,Nspecies,Nspecies)
        real*8 v(0:volume-1,Nspecies)
        real*8 mphase(0:toff-1)
        common/vectors/hub,v,mphase
        integer ix,iy,iz,addr
        real*8 ph

!       Calculate mphase - the phase vector needed in the measurement process
!       mphase = +1 on odd spatial sites
!       mphase = -1 on even spatial sites

        addr=0
        ph=1.d0
        do 35 iz=0,nx-1
        do 30 iy=0,ny-1
        do 25 ix=0,nz-1
        mphase(addr)=ph
        addr=addr+1
25        ph=-ph
30        ph=-ph
35        ph=-ph

        return
        end

!**************************indexset()************************
!       This subroutine sets and loads the index vectors
        subroutine indexset()
        implicit none
        integer nx,ny,nz,l,Nspecies,volume,toff
        parameter(nx=4,ny=4,nz=1,l=10,Nspecies=6)
        parameter(volume=nx*ny*nz*l,toff=nx*ny*nz)
!       index vectors for indirect addressing and phase vector
        integer xplus(0:toff-1),xminus(0:toff-1)
        integer yplus(0:toff-1),yminus(0:toff-1)
        integer zplus(0:toff-1),zminus(0:toff-1)

        common/ivectors/xplus,xminus,yplus,yminus,zplus,zminus
        save/ivectors/

        integer i,j

!       calculate the index vectors

        do 10 i=0,toff-1
            xplus(i) =i+1
            xminus(i)=i-1
            yplus(i) =i+nx
            yminus(i)=i-nx
            zplus(i) =i+nx*ny
            zminus(i)=i-nx*ny
10      continue

!	FIX THINGS UP

        do 20 i=nx-1,toff-1,nx
            xplus(i)=i-nx+1
20      continue
        do 25 i=0,toff-1,nx
            xminus(i)=i+nx-1
25      continue

        do 32 j=1,nz
            do 30 i=0,nx-1
                yplus(j*nx*ny-nx+i  )=(j-1)*nx*ny+i
                yminus((j-1)*nx*ny+i)=j*nx*ny-nx+i
30      continue
32      continue

        do 40 i=0,nx*ny-1
            zminus(i)=nx*ny*nz-nx*ny+i
            zplus(nx*ny*nz-nx*ny+i)=i
40      continue

!	SOME TRIVIAL CONSISTENCY CHECKS:

        do 100 i=0,toff-1
            if (xminus(xplus(i)).ne.i) then
                write (6,*) ' xplus/xminus problem at i=',i
                stop
            endif
            if (yminus(yplus(i)).ne.i) then
                write (6,*) ' yplus/yminus problem at i=',i
                stop
            endif
            if (zminus(zplus(i)).ne.i) then
                write (6,*) ' zplus/zminus problem at i=',i
                stop
            endif
100     continue

        do 110 i=0,toff-1
            j=zplus(yplus(xplus(i)))
            if (zminus(yminus(xminus(j))).ne.i) then
                write (6,*) ' plaquette problem at i=',i
                stop
            endif
110     continue

        return
        end

!**************************readin()**************************
!		This subroutine must read the information from .in files
!		Also needs to receive the Nspecies??
        subroutine readin()
        implicit none
        integer nx,ny,nz,l,Nspecies,volume,toff
        parameter(nx=4,ny=4,nz=1,l=10,Nspecies=6)
        parameter(volume=nx*ny*nz*l,toff=nx*ny*nz)

        integer warms,sweeps,nwrap
        integer iran
        common/integers/warms,sweeps,nwrap, iran
        integer orthlen,torth
        real*8 eorth,difflim,errpam
        common/getgpam/eorth,difflim,errpam,orthlen,
     1                torth
        save /getgpam/

!       BEGIN ==================================================================
        real*8 sgn(Nspecies)
        real*8 n_species(Nspecies)
        real*8 nud(Nspecies,Nspecies)
        real*8 ke(Nspecies)
        real*8 sgntot
!       END ====================================================================

!       BEGIN ==================================================================
        real*8 asgn_species(Nspecies),asgn,an(Nspecies)
        real*8 anud(Nspecies,Nspecies)
        real*8 ake(Nspecies)
!       END ====================================================================

!       FOLLOWING NEEDS CHANGES?
        real*8 grfun(0:nx/2,0:ny/2,0:0)
        real*8 spinxx(0:nx/2,0:ny/2,0:0)
        real*8 spinzz(0:nx/2,0:ny/2,0:0)
!        real*8 asgnup,asgndn,asgn,anup,andn,anud,ake
        real*8 agrfun(0:nx/2,0:ny/2,0:0)
        real*8 aspinxx(0:nx/2,0:ny/2,0:0)
        real*8 aspinzz(0:nx/2,0:ny/2,0:0)
        real*8 den(0:nx/2,0:ny/2,0:0,0:1)
        real*8 aden(0:nx/2,0:ny/2,0:0,0:1)
        real*8 errrat

!       BEGIN ==================================================================
        real*8 spinab(0:nx/2,0:ny/2,0:0,Nspecies,Nspecies)
        real*8 aspinab(0:nx/2,0:ny/2,0:0,Nspecies,Nspecies)
!       END ====================================================================

        common/m0var/ sgntot,
     1       grfun,spinxx,spinzz,aspinxx,aspinzz,asgn,
     2       den,aden,agrfun,errrat,spinab,aspinab

        common/m0vects/ sgn,n_species,asgn_species,an,nud,ke,anud,ake

        real*8 tx,u,mu,dtau,expmuch,expmuchi,gam,lambda,txdtau
        common/couple/tx,u,mu,dtau,expmuch,expmuchi,gam,lambda,txdtau
        real*8 ty,tydtau,tz,tzdtau
        common/couple2/ty,tydtau,tz,tzdtau
        real*8 chx,ch2x,chy,ch2y,chz,ch2z
        real*8 socx,socy,socz
        common/kinetic/socx,socy,socz
        save/kinetic/

        real*8 temp

        write(6,*) 'enter warms and sweeps'
        read(5,*) warms,sweeps
        write(76,*) 'warms=',warms,'  sweeps=',sweeps
        write(78,*) 'warms=',warms,'  sweeps=',sweeps

c        write(6,*)'enter tx,ty,tz,u,mu '
c        read(5,*) tx,ty,tz,u,mu
        write(6,*)'enter tx,ty,u,mu '
        read(5,*) tx,ty,u,mu
c        write(76,*) 'tx=',tx,'  ty=',ty,'  tz	=',tz
        write(76,*) 'tx=',tx,'  ty=',ty
        write(76,*) '  u=',u,'  mu =',mu
c        write(78,*) 'tx=',tx,'  ty=',ty,'  tz	=',tz
        write(78,*) 'tx=',tx,'  ty=',ty
        write(78,*) '  u=',u,'  mu =',mu

        write(6,*) 'enter dtau, nwrap, difflim, errrat'
        read(5,*)dtau,nwrap,difflim,errrat
        write(76,*)'dtau=',dtau,' nwrap = ',nwrap,
     1         ' difflim= ', difflim,' errrat= ',errrat
        write(78,*)'dtau=',dtau,' nwrap = ',nwrap,
     1         ' difflim= ', difflim,' errrat= ',errrat

        write(6,*) 'enter  orthlen, eorth'
        read(5,*)orthlen,eorth
        write(76,*)' orthlen= ',orthlen,
     1   ' eorth= ',eorth
        write(78,*)' orthlen= ',orthlen,
     1   ' eorth= ',eorth

        write(6,*) 'enter torth'
        read(5,*)torth
        write(76,*)' torth= ',torth
        write(78,*)' torth= ',torth

        gam = 0.5d0
        errpam = 1.0d13
        write(76,*)'errpam is ',errpam
        write(78,*)'errpam is ',errpam

        txdtau=tx*dtau
        tydtau=ty*dtau
        tzdtau=tz*dtau
        temp = dexp(dtau*u*0.5d0)
        lambda = dlog(temp+dsqrt(temp**2-1.d0))
        write(76,*)'lambda is ',lambda
        write(78,*)'lambda is ',lambda
        expmuch=dexp(mu*dtau)
        expmuchi=1.d0/expmuch
        chx = dcosh(txdtau)
        socx = dsinh(txdtau)/chx
        ch2x = chx**2
        chy = dcosh(tydtau)
        socy = dsinh(tydtau)/chy
        ch2y = chy**2
        chz = dcosh(tzdtau)
        socz = dsinh(tzdtau)/chz
        ch2z = chz**2
        expmuch =expmuch *ch2x*ch2y*ch2z
        expmuchi=expmuchi*ch2x*ch2y*ch2z

        write(6,*)'enter random number seed'
        read(5,*)iran
        write(76,*) 'iran=',iran
        write(78,*) 'iran=',iran

        return
        end

!*****************************ranlat()*****************************

!        This subroutine makes a lattice with random values for the
!        Hubbard-Stratanovich variables.

        subroutine ranlat()
        implicit none
        integer nx,ny,nz,l,Nspecies,volume,toff
        parameter(nx=4,ny=4,nz=1,l=10,Nspecies=6)
        parameter(volume=nx*ny*nz*l,toff=nx*ny*nz)
        integer warms,sweeps,nwrap
        integer iran
        common/integers/warms,sweeps,nwrap, iran

        real*8 hub(0:volume-1,Nspecies,Nspecies)
        real*8 v(0:volume-1,Nspecies)
        real*8 mphase(0:toff-1),ran2
        common/vectors/hub,v,mphase

        integer i,ispecies,jspecies
        real*8 ranf


        do 10 i=0,volume-1
            do ispecies=1, Nspecies
                do jspecies=1,Nspecies
                    hub(i,ispecies,jspecies)=1.d0
                    ranf = ran2(iran)
                    if(ranf .gt. 0.5) hub(i,ispecies,jspecies) = -1.d0
                end do
            end do
10      continue

        call setvup()

        return
        end

! ************************GETERR*****************************
        subroutine geterr(bin,ave,err)
!       variable number of bins, 4/25/95 by Martin Ulmke
        integer nbin
        real*8 err,sum,sumsq,ave,rbin
        parameter(nbin=10)
        real*8 bin(nbin)
        integer i

        rbin = dfloat(nbin-1)
        sum = 0.d0
        do 10 i = 1, nbin
10          sum = sum + bin(i)
        ave = sum /nbin
        sumsq = 0.d0
        do 20 i = 1, nbin
20          sumsq = sumsq + (bin(i)-ave)**2
        sumsq = sumsq /nbin
!        err = dsqrt(sumsq)/3.d0
        err = dsqrt(sumsq/rbin)
        if(err*1.0d12 .lt. dabs(ave)) err = 0.d0
        return
        end

!************************GETERR2*****************************
        subroutine geterr2(sum,sumsq,ave,err)
!       variable number of bins, 4/25/95 by Martin Ulmke
        integer nbin
        real*8 err,sum,sumsq,ave,ssq,rbin
        parameter(nbin=10)

        rbin = dfloat(nbin-1)
        ave = sum /nbin
        ssq = sumsq /nbin - ave**2
        err = dsqrt(dabs(ssq)/rbin)
        if(err*1.0d12 .lt. dabs(ave)) err = 0.d0
        return
        end


!*******************************multt(m,lr)********************

!        This subroutine multiplies m by the matrix T on the
!        left or right depending on whether lr = -1 or 1.
!        The factor expmu is also included.
!        This is the real*8 version.

        subroutine multt(mat,lr)
        implicit none
        integer nx,ny,nz,l,Nspecies,volume,toff
        parameter(nx=4,ny=4,nz=1,l=10,Nspecies=6)
        parameter(volume=nx*ny*nz*l,toff=nx*ny*nz)

        real*8 tx,u,mu,dtau,expmuch,expmuchi,gam,lambda,txdtau
        common/couple/tx,u,mu,dtau,expmuch,expmuchi,gam,lambda,txdtau
        real*8 socx,socy,socz
        common/kinetic/socx,socy,socz
        save /kinetic/
        real*8 rux(0:toff,0:toff)
        integer xplus(0:toff-1),xminus(0:toff-1)
        integer yplus(0:toff-1),yminus(0:toff-1)
        integer zplus(0:toff-1),zminus(0:toff-1)
        common/ivectors/xplus,xminus,yplus,yminus,zplus,zminus
        save/ivectors/

        real*8 mat(0:toff,0:toff)
        integer i,j,k,lr,i1,i2

        if(lr .eq. -1) then
!       Do odd z first
c            do 20 k=nx*ny,toff,2*nx*ny
c                do 20 i=0,nx*ny-1
c                    i1=i+k
c                    i2=zplus(i1)
c                    do 20 j=0,toff-1
c                        rux(i1,j)=mat(i1,j)+socz*mat(i2,j)
c                        rux(i2,j)=mat(i2,j)+socz*mat(i1,j)
c20          continue

c       JUST SET rux TO mat
            do 20 i=0,toff-1
                do 20 j=0,toff-1
20          rux(i,j)=mat(i,j)

!       Do odd x first
            do 30 i=1,toff,2
                i1=i
                i2=xplus(i1)
                do 30 j=0,toff-1
                    mat(i1,j)=rux(i1,j)+socx*rux(i2,j)
                    mat(i2,j)=rux(i2,j)+socx*rux(i1,j)
30          continue
!       Do odd y next
            do 40 k=0,nx-1
                do 40 i=nx,toff-nx,2*nx
                    i1=i+k
                    i2=yplus(i1)
                    do 40 j=0,toff-1
                        rux(i1,j)=mat(i1,j)+socy*mat(i2,j)
                        rux(i2,j)=mat(i2,j)+socy*mat(i1,j)
40          continue
!       Do even y next
            do 50 k=0,nx-1
                do 50 i=0,toff-2*nx,2*nx
                    i1=i+k
                    i2=yplus(i1)
                    do 50 j=0,toff-1
                        mat(i1,j)=rux(i1,j)+socy*rux(i2,j)
                        mat(i2,j)=rux(i2,j)+socy*rux(i1,j)
50          continue
!       Do even x next
            do 60 i=0,toff-1,2
                i1=i
                i2=xplus(i1)
                do 60 j=0,toff-1
                    rux(i1,j)=mat(i1,j)+socx*mat(i2,j)
                    rux(i2,j)=mat(i2,j)+socx*mat(i1,j)
60          continue
!       Do even z next
c            do 70 k=0,toff-2*nx*ny,2*nx*ny
c                do 70 i=0,nx*ny-1
c                    i1=i+k
c                    i2=zplus(i1)
c                    do 70 j=0,toff-1
c                        mat(i1,j)=rux(i1,j)+socz*rux(i2,j)
c                        mat(i2,j)=rux(i2,j)+socz*rux(i1,j)
c70          continue

c       JUST SET mat TO rux
            do 70 i=0,toff-1
                do 70 j=0,toff-1
70          mat(i,j)=rux(i,j)

!       ch and expmu factors
            do 80 i=0,toff-1
                do 80 j=0,toff-1
                    mat(i,j)=mat(i,j)*expmuch
80          continue

        else

!	    transpose mat
!       ch and expmu factors
            do 180 i=0,toff-1
                do 180 j=0,toff-1
                    rux(i,j)=mat(j,i)*expmuch
180         continue

!       Do even z next

c            do 170 k=0,toff-2*nx*ny,2*nx*ny
c                do 170 i=0,nx*ny-1
c                    i1=i+k
c                    i2=zplus(i1)
c                    do 170 j=0,toff-1
c                        mat(i1,j)=rux(i1,j)+socz*rux(i2,j)
c                        mat(i2,j)=rux(i2,j)+socz*rux(i1,j)
c170         continue

c       JUST SET mat TO rux
            do 170 i=0,toff-1
                do 170 j=0,toff-1
170          mat(i,j)=rux(i,j)

!       Do even x next
            do 160 i=0,toff-1,2
                i1=i
                i2=xplus(i1)
                do 160 j=0,toff-1
                    rux(i1,j)=mat(i1,j)+socx*mat(i2,j)
                    rux(i2,j)=mat(i2,j)+socx*mat(i1,j)
160         continue
!       Do even y next
            do 150 k=0,nx-1
                do 150 i=0,toff-2*nx,2*nx
                    i1=i+k
                    i2=yplus(i1)
                    do 150 j=0,toff-1
                        mat(i1,j)=rux(i1,j)+socy*rux(i2,j)
                        mat(i2,j)=rux(i2,j)+socy*rux(i1,j)
150         continue
!       Do odd y next
            do 140 k=0,nx-1
                do 140 i=nx,toff-nx,2*nx
                    i1=i+k
                    i2=yplus(i1)
                    do 140 j=0,toff-1
                        rux(i1,j)=mat(i1,j)+socy*mat(i2,j)
                        rux(i2,j)=mat(i2,j)+socy*mat(i1,j)
140         continue
!       Do odd x first
            do 130 i=1,toff,2
                i1=i
                i2=xplus(i1)
                do 130 j=0,toff-1
                    mat(i1,j)=rux(i1,j)+socx*rux(i2,j)
                    mat(i2,j)=rux(i2,j)+socx*rux(i1,j)
130         continue

!       Do odd z first
c            do 120 k=nx*ny,toff,2*nx*ny
c                do 120 i=0,nx*ny-1
c                    i1=i+k
c                    i2=zplus(i1)
c                    do 120 j=0,toff-1
c                        rux(i1,j)=mat(i1,j)+socz*mat(i2,j)
c                        rux(i2,j)=mat(i2,j)+socz*mat(i1,j)
c120         continue

c       JUST SET rux TO mat
            do 120 i=0,toff-1
                do 120 j=0,toff-1
120          rux(i,j)=mat(i,j)

!	    transpose mat again
            do 110 i=0,toff-1
                do 110 j=0,toff-1
                    mat(i,j)=rux(j,i)
110         continue
        endif

        return
        end

!*******************************multti(m,lr)********************

!        This subroutine multiplies m by the matrix T^-1 on the
!        left or right depending on whether lr = -1 or 1.
!        The factor expmu^-1 is also included.
!        This is the real*8 version.

        subroutine multti(mat,lr)
        implicit none
        integer nx,ny,nz,l,Nspecies,volume,toff
        parameter(nx=4,ny=4,nz=1,l=10,Nspecies=6)
        parameter(volume=nx*ny*nz*l,toff=nx*ny*nz)

        real*8 tx,u,mu,dtau,expmuch,expmuchi,gam,lambda,txdtau
        common/couple/tx,u,mu,dtau,expmuch,expmuchi,gam,lambda,txdtau
        real*8 socx,socy,socz
        common/kinetic/socx,socy,socz
        save /kinetic/
        integer xplus(0:toff-1),xminus(0:toff-1)
        integer yplus(0:toff-1),yminus(0:toff-1)
        integer zplus(0:toff-1),zminus(0:toff-1)
        common/ivectors/xplus,xminus,yplus,yminus,zplus,zminus
        save/ivectors/

        real*8 rux(0:toff,0:toff)
        real*8 mat(0:toff,0:toff)
        integer i,j,k,lr,i1,i2

        if(lr .eq. 1) then
!       transpose
            do 10 i=0,toff-1
                do 10 j=0,toff-1
                    rux(i,j)=mat(j,i)
10          continue

!       Do odd z first
c            do 20 k=nx*ny,toff,2*nx*ny
c                do 20 i=0,nx*ny-1
c                    i1=i+k
c                    i2=zplus(i1)
c                    do 20 j=0,toff-1
c                        mat(i1,j)=rux(i1,j)-socz*rux(i2,j)
c                        mat(i2,j)=rux(i2,j)-socz*rux(i1,j)
c20          continue

c       JUST SET mat TO rux
            do 20 i=0,toff-1
                do 20 j=0,toff-1
20          mat(i,j)=rux(i,j)

!       Do odd x first
            do 30 i=1,toff,2
                i1=i
                i2=xplus(i1)
                do 30 j=0,toff-1
                    rux(i1,j)=mat(i1,j)-socx*mat(i2,j)
                    rux(i2,j)=mat(i2,j)-socx*mat(i1,j)
30          continue
!       Do odd y next
            do 40 k=0,nx-1
                do 40 i=nx,toff-nx,2*nx
                    i1=i+k
                    i2=yplus(i1)
                    do 40 j=0,toff-1
                        mat(i1,j)=rux(i1,j)-socy*rux(i2,j)
                        mat(i2,j)=rux(i2,j)-socy*rux(i1,j)
40          continue
!       Do even y next
            do 50 k=0,nx-1
                do 50 i=0,toff-2*nx,2*nx
                    i1=i+k
                    i2=yplus(i1)
                    do 50 j=0,toff-1
                        rux(i1,j)=mat(i1,j)-socy*mat(i2,j)
                        rux(i2,j)=mat(i2,j)-socy*mat(i1,j)
50          continue
!       Do even x next
            do 60 i=0,toff-1,2
                i1=i
                i2=xplus(i1)
                do 60 j=0,toff-1
                    mat(i1,j)=rux(i1,j)-socx*rux(i2,j)
                    mat(i2,j)=rux(i2,j)-socx*rux(i1,j)
60          continue

!       Do even z next
c            do 70 k=0,toff-2*nx*ny,2*nx*ny
c                do 70 i=0,nx*ny-1
c                    i1=i+k
c                    i2=zplus(i1)
c                    do 70 j=0,toff-1
c                        rux(i1,j)=mat(i1,j)-socz*mat(i2,j)
c                        rux(i2,j)=mat(i2,j)-socz*mat(i1,j)
c70          continue

c       JUST SET rux TO mat
            do 70 i=0,toff-1
                do 70 j=0,toff-1
70          rux(i,j)=mat(i,j)

!       ch and expmu factors
!       transpose
            do 80 i=0,toff-1
                do 80 j=0,toff-1
                    mat(i,j)=rux(j,i)*expmuchi
80          continue

        else

!       ch and expmu factors
            do 180 i=0,toff-1
                do 180 j=0,toff-1
                    rux(i,j)=mat(i,j)*expmuchi
180         continue

!       Do even z next
c            do 170 k=0,toff-2*nx*ny,2*nx*ny
c                do 170 i=0,nx*ny-1
c                    i1=i+k
c                    i2=zplus(i1)
c                    do 170 j=0,toff-1
c                        mat(i1,j)=rux(i1,j)-socz*rux(i2,j)
c                        mat(i2,j)=rux(i2,j)-socz*rux(i1,j)
c170         continue

c       JUST SET mat TO rux
            do 170 i=0,toff-1
                do 170 j=0,toff-1
170          mat(i,j)=rux(i,j)

!       Do even x next
            do 160 i=0,toff-1,2
                i1=i
                i2=xplus(i1)
                do 160 j=0,toff-1
                    rux(i1,j)=mat(i1,j)-socx*mat(i2,j)
                    rux(i2,j)=mat(i2,j)-socx*mat(i1,j)
160         continue
!       Do even y next
            do 150 k=0,nx-1
                do 150 i=0,toff-2*nx,2*nx
                    i1=i+k
                    i2=yplus(i1)
                    do 150 j=0,toff-1
                        mat(i1,j)=rux(i1,j)-socy*rux(i2,j)
                        mat(i2,j)=rux(i2,j)-socy*rux(i1,j)
150         continue
!       Do odd y next
            do 140 k=0,nx-1
                do 140 i=nx,toff-nx,2*nx
                    i1=i+k
                    i2=yplus(i1)
                    do 140 j=0,toff-1
                        rux(i1,j)=mat(i1,j)-socy*mat(i2,j)
                        rux(i2,j)=mat(i2,j)-socy*mat(i1,j)
140         continue
!       Do odd x first
            do 130 i=1,toff,2
                i1=i
                i2=xplus(i1)
                do 130 j=0,toff-1
                    mat(i1,j)=rux(i1,j)-socx*rux(i2,j)
                    mat(i2,j)=rux(i2,j)-socx*rux(i1,j)
130         continue

!       Do odd z first
c            do 120 k=nx*ny,toff,2*nx*ny
c                do 120 i=0,nx*ny-1
c                    i1=i+k
c                    i2=zplus(i1)
c                    do 120 j=0,toff-1
c                        rux(i1,j)=mat(i1,j)-socz*mat(i2,j)
c                        rux(i2,j)=mat(i2,j)-socz*mat(i1,j)
c120         continue

c       JUST SET rux TO mat
            do 120 i=0,toff-1
                do 120 j=0,toff-1
120          rux(i,j)=mat(i,j)

!       put back in mat
            do 110 i=0,toff-1
                do 110 j=0,toff-1
                    mat(i,j)=rux(i,j)
110         continue
        endif

        return
        end

!*****************************getgp()*******************************

! getgp -- routine to include pivoting in the orthogonalization. 06/17/19

        subroutine getgp(vvv,ti,gmat,sgndet,deta,lndeta)
        implicit none
        integer nx,ny,nz,l,Nspecies,volume,toff
        parameter(nx=4,ny=4,nz=1,l=10,Nspecies=6)
        parameter(volume=nx*ny*nz*l,toff=nx*ny*nz)
        integer orthlen,torth
        real*8 eorth,difflim,errpam
        common/getgpam/eorth,difflim,errpam,orthlen,
     1                torth
        save /getgpam/
        integer i,j,mx,k,my,kk,ti,depth

        real*8 vvv(0:volume-1)
        real*8 gmat(0:toff,0:toff)

        real*8 rmat(0:toff,0:toff),rmat2(0:toff,0:toff)
        real*8 rmat3(0:toff,0:toff)
        real*8 oimat(0:toff,0:toff),omat(0:toff,0:toff)
        real*8 omat2(0:toff,0:toff),omat3(0:toff,0:toff)

        real*8 bvec(0:toff),sgndet,det,deta,lndeta,lndet
        integer ipvt(toff),nbig

        nbig=0
        call unit(omat)
        call unit(rmat)
        do 10 mx = 0, toff-1
10          bvec(mx) = 1.d0
        do 40 i = 0, l-1
            kk = mod(i+ti+l,l)
            call multb(omat,vvv,kk,-1)
            if(mod(i+1,orthlen) .eq. 0 .or. i .eq. l-1)then
                do 30 my = 0, toff-1
                    do 30 mx = 0, toff-1
30                      omat(mx,my) = omat(mx,my) * bvec(my)
                        depth = toff
                        call orthfacp(omat,bvec,rmat2,depth)
                        call matmult(rmat2,rmat,rmat3)
                        call matcop(rmat3,rmat)
            endif
40      continue
!       One last orthogonalization to make sure omat is orthogonal.
        do 35 my = 0, toff-1
            do 35 mx = 0, toff-1
35              omat(mx,my) = omat(mx,my) * bvec(my)
                call orthfacp(omat,bvec,rmat2,depth)
                call matmult(rmat2,rmat,rmat3)
                call matcop(rmat3,rmat)

!       oimat = omat^-1
        call invertr(omat,oimat,det,lndet,toff+1,toff,2,ipvt)
        deta=det
        lndeta=lndet
        sgndet = 1.d0
        if(det .lt. 0.d0) sgndet = -1.d0
!       rmat2 = rmat^-1
        call invertr(rmat,rmat2,det,lndet,toff+1,toff,2,ipvt)
        deta=deta*det
        lndeta=lndeta+lndet

!       Calculate omat2 = D + omat^-1 R^-1
!       Dimension of omat2 is toff-nbig.
        call zeromat(omat2)
        do 65 i = 0, toff-1
65          omat2(i,i) = bvec(i)
        do 60 k = 0, toff-1
            do 60 j = 0, toff-1
                do 60 i = 0, toff-1
60                  omat2(i,j)=omat2(i,j)+oimat(i,k)*rmat2(k,j)
!       calculate inverse of omat2, put in omat3
        call invertr(omat2,omat3,det,lndet,toff+1,toff-0,2,ipvt)
        deta=deta*det
        lndeta=lndeta+lndet
        if(det .lt. 0.0) sgndet = -sgndet

        call zeromat(omat)
        do 80 i = 0,toff-1
            do 80 j = 0,toff-1
                do 80 k = 0,toff-1
80               omat(i,k) = omat(i,k) + omat3(i-nbig,j-nbig)*oimat(j,k)

!       Multiply to get gmat=rmat2*omat.
!       Remember:omat(j,k) = 0 for j < 0
        call zeromat(gmat)
        do 95 i = 0,toff-1
            do 95 j = nbig,toff-1
                do 95 k = 0,toff-1
95                  gmat(i,k) = gmat(i,k) + rmat2(i,j)*omat(j,k)

        return
        end


!****************************orthogp********************************
!		 NEW VERSION  (with pivoting)
        subroutine orthogp(mat,rmat,depth)
        implicit none
        integer nx,ny,nz,l,Nspecies,volume,toff
        parameter(nx=4,ny=4,nz=1,l=10,Nspecies=6)
        parameter(volume=nx*ny*nz*l,toff=nx*ny*nz)

        integer i,j,k,depth, done(0:toff-1),ib
        real*8 mat(0:toff,0:toff),rmat(0:toff,0:toff),maxsize,colsize
!
        call unit(rmat)
        do 10 i = 0, toff-1
10          done(i) = 0
!       done(i)=0 means the other columns havent been orthogonalized to col i yet.
        do 20 i = 0, min(depth,toff)-1
!       First find the column which is largest and hasn't been done yet.
!       That col. will be "ib".
            maxsize = -10.d0
            ib = -1
            do 30 j = 0, toff-1
                if(done(j) .eq. 0)then
                    colsize = 0.d0
                    do 40 k=0, toff-1
40                      colsize = colsize + mat(k,j)**2
                    if(colsize .gt. maxsize) then
                        maxsize = colsize
                        ib = j
                    endif
                endif
30          continue
            done(ib) = 1
            call donorm(mat(0,ib),rmat(ib,ib))
!       Now orthogonalize all the other columns to ib.
            do 50 j = 0, toff-1
                if(done(j) .eq. 0) then
                    do 60 k=0, toff-1
60                      rmat(ib,j) = rmat(ib,j) + mat(k,ib)*mat(k,j)
                    do 70 k=0, toff-1
70                      mat(k,j) = mat(k,j) - rmat(ib,j)*mat(k,ib)
                endif
50          continue

20      continue

        return
        end

!****************************orthfacp*******************************

        subroutine orthfacp(mat,dvec,rmat,depth)
        implicit none
        integer nx,ny,nz,l,Nspecies,volume,toff
        parameter(nx=4,ny=4,nz=1,l=10,Nspecies=6)
        parameter(volume=nx*ny*nz*l,toff=nx*ny*nz)
        integer i,j,depth
        real*8 mat(0:toff,0:toff),rmat(0:toff,0:toff),dvec(0:toff-1)
        real*8 temp
!
        call orthogp(mat,rmat,depth)
        do 10 i = 0, toff-1
            dvec(i) = rmat(i,i)
            if(dvec(i) .eq. 0.d0) then
                rmat(i,i) = 1.d0
            else if(dvec(i) .ne. 1.d0) then
                temp = 1.d0 / dvec(i)
                do 20 j = 0, toff-1
20                  rmat(i,j) = rmat(i,j) * temp
            endif
10      continue
        return
        end


!*****************************unit(mat)*****************************

!        This subroutine puts the unit matrix in aux, which is real*8.

        subroutine unit(mat)
        implicit none
        integer nx,ny,nz,l,Nspecies,volume,toff
        parameter(nx=4,ny=4,nz=1,l=10,Nspecies=6)
        parameter(volume=nx*ny*nz*l,toff=nx*ny*nz)
        real*8 mat(0:toff,0:toff)
        integer i,j
        do 10 i = 0, toff-1
            do 20 j = 0, toff-1
20              mat(i,j) = 0.d0
10          mat(i,i) = 1.d0
        return
        end

!*****************************multb(m,vvv,ti,lr)********************

!        This subroutine multiplies m by the matrix B(ti) on the
!        left or right depending on whether lr = -1 or 1.
!        This is the real*8 version.

        subroutine multb(mat,vvv,ti,lr)
        implicit none
        integer nx,ny,nz,l,Nspecies,volume,toff
        parameter(nx=4,ny=4,nz=1,l=10,Nspecies=6)
        parameter(volume=nx*ny*nz*l,toff=nx*ny*nz)
        real*8 vvv(0:volume-1)
        real*8 mat(0:toff,0:toff)
        integer i,j,ti,lr

        if(lr .eq. -1) then
            call multt(mat,lr)
            do 10 i = 0, toff-1
                do 10 j = 0, toff-1
10                  mat(i,j) = mat(i,j) * vvv(i+toff*ti)
        else
            do 20 j = 0, toff-1
                do 20 i = 0, toff-1
20                  mat(i,j) = mat(i,j) * vvv(j+toff*ti)
            call multt(mat,lr)
        endif

        return
        end

!*****************************multbi(m,vvv,ti,lr)********************

!        This subroutine multiplies m by the matrix B(ti)^-1 on the
!        left or right depending on whether lr = -1 or 1.
!        This is the real*8 version.

        subroutine multbi(mat,vvv,ti,lr)
        implicit none
        integer nx,ny,nz,l,Nspecies,volume,toff
        parameter(nx=4,ny=4,nz=1,l=10,Nspecies=6)
        parameter(volume=nx*ny*nz*l,toff=nx*ny*nz)
        real*8 vvv(0:volume-1)
        real*8 mat(0:toff,0:toff)
        integer i,j,ti,lr

        if(lr .eq. 1) then
            call multti(mat,lr)
            do 10 j = 0, toff-1
                do 10 i = 0, toff-1
10                  mat(i,j) = mat(i,j) / vvv(j+toff*ti)
        else
            do 20 i = 0, toff-1
                do 20 j = 0, toff-1
20                  mat(i,j) = mat(i,j) / vvv(i+toff*ti)
            call multti(mat,lr)
        endif

        return
        end

!****************************zeromat(mat)****************************
!        This subroutine zeroes mat.

        subroutine zeromat(mat)
        implicit none
        integer nx,ny,nz,l,Nspecies,volume,toff
        parameter(nx=4,ny=4,nz=1,l=10,Nspecies=6)
        parameter(volume=nx*ny*nz*l,toff=nx*ny*nz)
        real*8 mat(0:toff,0:toff)
        integer i,j
        do 20 i = 0, toff-1
            do 20 j = 0, toff-1
20              mat(i,j) = 0.d0
        return
        end

!******************************transp(mat,aux)***********************
!        This subroutine multiplies mat by the even-x matrix

        subroutine transp(mat,aux)
        implicit none
        integer nx,ny,nz,l,Nspecies,volume,toff
        parameter(nx=4,ny=4,nz=1,l=10,Nspecies=6)
        parameter(volume=nx*ny*nz*l,toff=nx*ny*nz)

        integer i,j
        real*8 mat(0:toff,0:toff),aux(0:toff,0:toff)

        do 20 i = 0, toff-1, 4
            do 20 j = 0, toff-1
                aux(i,j)   = mat(j,i)
                aux(i+1,j) = mat(j,i+1)
                aux(i+2,j) = mat(j,i+2)
                aux(i+3,j) = mat(j,i+3)
20      continue
        return
        end

!******************************matrixmultiplication******************
! 		  This subroutine multiplies matrices (in a weird way honestly)
        subroutine matmult(mat1,mat2,mat3)
        implicit none
        integer nx,ny,nz,l,Nspecies,volume,toff
        parameter(nx=4,ny=4,nz=1,l=10,Nspecies=6)
        parameter(volume=nx*ny*nz*l,toff=nx*ny*nz)
        integer i,j,k
        real*8 mat1(0:toff,0:toff),mat2(0:toff,0:toff)
        real*8 mat3(0:toff,0:toff)

        do 10 i = 0, toff-1
            do 10 j = 0, toff-1
10              mat3(i,j) = 0.d0
        do 20 j = 0, toff-1
            do 20 k = 0, toff-1
                do 20 i = 0, toff-1
20                  mat3(i,j) = mat3(i,j) + mat1(i,k)*mat2(k,j)
        return
        end

!******************************absdiffoftwomatrices******************
! 		  Not sure where is used in the code, but ok.
        subroutine matdif(mat1,mat2,diff)
        implicit none
        integer nx,ny,nz,l,Nspecies,volume,toff
        parameter(nx=4,ny=4,nz=1,l=10,Nspecies=6)
        parameter(volume=nx*ny*nz*l,toff=nx*ny*nz)
        integer i,j
        real*8 mat1(0:toff,0:toff),mat2(0:toff,0:toff),diff

        diff = 0.d0
        do 10 i = 0, toff-1
            do 10 j = 0, toff-1
10              diff = diff + (mat1(i,j) - mat2(i,j))**2
        diff = dsqrt(diff) / (toff)
        return
        end

!******************************matrixcopy****************************
!		  Makes a copy of a given matrix
        subroutine matcop(mat1,mat2)
        implicit none
        integer nx,ny,nz,l,Nspecies,volume,toff
        parameter(nx=4,ny=4,nz=1,l=10,Nspecies=6)
        parameter(volume=nx*ny*nz*l,toff=nx*ny*nz)
        integer i,j
        real*8 mat1(0:toff,0:toff),mat2(0:toff,0:toff)

        do 10 i = 0, toff-1
            do 10 j = 0, toff-1
10              mat2(i,j) = mat1(i,j)
        return
        end

!******************************vectornorm****************************
        subroutine donorm(vec,vnorm)
        implicit none
        integer nx,ny,nz,l,Nspecies,volume,toff
        parameter(nx=4,ny=4,nz=1,l=10,Nspecies=6)
        parameter(volume=nx*ny*nz*l,toff=nx*ny*nz)
        integer i
        real*8 vec(0:toff),vnorm,temp

        temp = 0.d0
        do 10 i = 0, toff-1
10          temp = temp + vec(i)**2
        vnorm = dsqrt(temp)
        if(vnorm .ne. 0.d0) then
            temp = 1.d0 / vnorm
            do 20 i = 0, toff-1
20              vec(i) = vec(i) * temp
        endif
        return
        end

!******************************meas0(lots of variables)**************

!        This subroutine does the measurements.
!		 This subroutine requieres changes to gmatup, gmatdn. I'll come back
!		 LATTER. I THINK THIS SUBROUTINE REQUIERES THE MOST CHANGES HONESTLY.

        subroutine meas0(gmat)
        implicit none
        integer nx,ny,nz,l,Nspecies,volume,toff
        parameter(nx=4,ny=4,nz=1,l=10,Nspecies=6)
        parameter(volume=nx*ny*nz*l,toff=nx*ny*nz)

        real*8 tx,u,mu,dtau,expmuch,expmuchi,gam,lambda,txdtau
        common/couple/tx,u,mu,dtau,expmuch,expmuchi,gam,lambda,txdtau
        real*8 ty,tydtau,tz,tzdtau
        common/couple2/ty,tydtau,tz,tzdtau

!       index vectors for indirect addressing and phase vector
        integer xplus(0:toff-1),xminus(0:toff-1)
        integer yplus(0:toff-1),yminus(0:toff-1)
        integer zplus(0:toff-1),zminus(0:toff-1)
        common/ivectors/xplus,xminus,yplus,yminus,zplus,zminus
        save/ivectors/

!       BEGIN =====================================================================
!       NEED TO DECIDE HERE WHAT TO DO WITH HOW MEAS0 IS CALLED
        real*8 gmat(0:toff,0:toff,Nspecies)
        real*8 hub(0:volume-1,Nspecies,Nspecies)
        real*8 v(0:volume-1,Nspecies)
!       END =======================================================================
!       NEXT BLOCK NEEDS TO BE CHANGED

        real*8 mphase(0:toff-1)

!       BEGIN ==================================================================
        real*8 sgn(Nspecies)
        real*8 n_species(Nspecies)
        real*8 sgntot
        real*8 nud(Nspecies,Nspecies)
        real*8 ke(Nspecies)
!       END ====================================================================

!        real*8 sgnup,sgndn,sgn,nup,ndn,nud,ke
        real*8 grfun(0:nx/2,0:ny/2,0:0)
        real*8 spinxx(0:nx/2,0:ny/2,0:0)
        real*8 spinzz(0:nx/2,0:ny/2,0:0)
        integer nmeas0,redo,noredo

!       BEGIN ==================================================================
        real*8 asgn_species(Nspecies),asgn,an(Nspecies)
        real*8 anud(Nspecies,Nspecies)
        real*8 ake(Nspecies)
!       END ====================================================================

        real*8 agrfun(0:nx/2,0:ny/2,0:0)
        real*8 aspinxx(0:nx/2,0:ny/2,0:0)
        real*8 aspinzz(0:nx/2,0:ny/2,0:0)
        real*8 den(0:nx/2,0:ny/2,0:0,0:1)
        real*8 aden(0:nx/2,0:ny/2,0:0,0:1)
        real*8 errrat

!       BEGIN ==================================================================
        real*8 spinab(0:nx/2,0:ny/2,0:0,Nspecies,Nspecies)
        real*8 aspinab(0:nx/2,0:ny/2,0:0,Nspecies,Nspecies)
!       END ====================================================================

!       BEGIN ==================================================================
        common/m0vects/ sgn,n_species,asgn_species,an,nud,ke,anud,ake

        common/m0var/ sgntot,
     1       grfun,spinxx,spinzz,aspinxx,aspinzz,
     2       asgn,den,aden,agrfun,errrat,spinab,aspinab

        common/m0vari/nmeas0,redo,noredo

        common/vectors/hub,v,mphase
!       END ====================================================================

!       NEXT LINES NEED TO BE CHANGED, BY A LOT!
c        real*8 gmat_i(0:toff,0:toff)
c        real*8 gmat_j(0:toff,0:toff)
c        real*8 v_i(0:volume-1),v_j(0:volume-1)
c        real*8 gtemp,xxtemp,zztemp
        real*8 kex(Nspecies),key(Nspecies),kez(Nspecies)

        integer i,j,ix,jx,iy,jy,kx,ky,kz,iz,jz,xfac,yfac,zfac
        integer ispecies,jspecies

!       BEGIN ==================================================================
        do ispecies=1,Nspecies
            n_species(ispecies) = 0.d0
            ke(ispecies) = 0.d0
            kex(ispecies) = 0.d0
            key(ispecies) = 0.d0
            kez(ispecies) = 0.d0
        end do

        do ispecies=1,Nspecies-1
            do jspecies=ispecies+1,Nspecies
                nud(ispecies,jspecies) = 0.d0
            end do
        end do
!       END ====================================================================

!c        do 30 kx = 0, nx/2
!c            do 30 ky = 0, ny/2
!c                do 30 kz = 0, 0
!c                    grfun(kx,ky,kz) = 0.d0
!c                    spinxx(kx,ky,kz) = 0.d0
!c                    spinzz(kx,ky,kz) = 0.d0
!c                    den(kx,ky,kz,0) = 0.d0
!c                    den(kx,ky,kz,1) = 0.d0
!c30      continue

!       BEGIN ==================================================================
        do ispecies=1,Nspecies
            do jspecies=1,Nspecies
                do kx=0,nx/2
                    do ky=0,ny/2
                        do kz=0,0
                            spinzz(kx,ky,kz)= 0.d0
                            spinab(kx,ky,kz,ispecies,jspecies) = 0.d0
                        end do
                    end do
                end do
            end do
        end do
!       END ====================================================================

        do 200 i = 0,toff-1
!       BEGIN ==================================================================
!       Measure occupancies and energies
            do ispecies=1,Nspecies
                n_species(ispecies) = n_species(ispecies) + 1.d0
     1           - gmat(i,i,ispecies)
                kex(ispecies) = kex(ispecies) + gmat(i,xplus(i),
     1           ispecies) + gmat(i,xminus(i),ispecies)
                key(ispecies) = key(ispecies) + gmat(i,yplus(i),
     1           ispecies) + gmat(i,yminus(i),ispecies)
                kez(ispecies) = kez(ispecies) + gmat(i,zplus(i),
     1           ispecies) + gmat(i,zminus(i),ispecies)
            end do
!       Measure double occupancies
            do ispecies=1,Nspecies-1
                do jspecies=ispecies+1,Nspecies
                    nud(ispecies,jspecies)=nud(ispecies,jspecies)+(1.d0-
     1               gmat(i,i,ispecies))*(1.d0-gmat(i,i,jspecies))
                end do
            end do
!       Measure kinetic energies

!       END ====================================================================
200     continue

!       BEGIN ==================================================================
        do ispecies=1,Nspecies
            spinab(0,0,0,ispecies,ispecies) = 1.d0*toff -
     1       n_species(ispecies)
        end do

        do 210 ix = 0,nx-1
            do 210 iy = 0,ny-1
                do 210 iz = 0,nz-1
                    i = ix+nx*iy+nx*ny*iz
        do 210 jx = 0,nx-1
            do 210 jy = 0,ny-1
                do 210 jz = 0,nz-1
                    j = jx+nx*jy+nx*ny*jz
                    kx = abs(ix-jx)
                    kx = min(kx,nx-kx)
                    ky = abs(iy-jy)
                    ky = min(ky,ny-ky)
                    kz = abs(iz-jz)
                    kz = min(kz,nz-kz)

                    do ispecies=1,Nspecies
                        do jspecies=1,Nspecies
                            if(ispecies .eq. jspecies)then
                                spinab(kx,ky,kz,ispecies,jspecies) =
     1                           spinab(kx,ky,kz,ispecies,jspecies) +
     2                           (1.d0 - gmat(i,i,ispecies))*
     3                           (1.d0 - gmat(j,j,ispecies)) -
     4                           (gmat(j,i,ispecies)*gmat(i,j,ispecies))
                            else
                                spinab(kx,ky,kz,ispecies,jspecies) =
     1                           spinab(kx,ky,kz,ispecies,jspecies) +
     2                           (1.d0 - gmat(i,i,ispecies))*
     3                           (1.d0 - gmat(j,j,jspecies))
                            endif
                        end do
                    end do
210     continue
!       END ====================================================================

!c        spinxx(0,0,0) = 2.d0*toff-(nup+ndn)
!c        spinzz(0,0,0) = 2.d0*toff-(nup+ndn)
!c        do 210 ix = 0,nx-1
!c         do 210 iy = 0,ny-1
!c         do 210 iz = 0,nz-1
!c          i = ix+nx*iy+nx*ny*iz
!c          do 210 jx = 0,nx-1
!c           do 210 jy = 0,ny-1
!c           do 210 jz = 0,nz-1
!c            j = jx+nx*jy+nx*ny*jz
!c            kx = abs(ix-jx)
!c            kx = min(kx,nx-kx)
!c            ky = abs(iy-jy)
!c            ky = min(ky,ny-ky)
!c            kz = abs(iz-jz)
!c            kz = min(kz,nz-kz)
!c            gtemp = gmatup(i,j)+ gmatdn(i,j)
!c            grfun(kx,ky,kz) = grfun(kx,ky,kz) + gtemp
! The following line is not correct for kx=ky=0, but it will be fixed later.
!c            den(kx,ky,kz,0) = den(kx,ky,kz,0)+
!c     1             (1.d0-gmatup(i,i))*(1.d0-gmatup(j,j)) +
!c     2             (1.d0-gmatdn(i,i))*(1.d0-gmatdn(j,j)) -
!c     3           gmatup(i,j)*gmatup(j,i)-gmatdn(i,j)*gmatdn(j,i)
!c            den(kx,ky,kz,1) = den(kx,ky,kz,1)+
!c     1             (1.d0-gmatup(i,i))*(1.d0-gmatdn(j,j))
!c            xxtemp = -2.d0*gmatup(i,j)*gmatdn(j,i)
!c            zztemp = (gmatup(i,i)*gmatup(j,j)
!c     1        +gmatdn(i,i)*gmatdn(j,j)-2.d0*gmatup(i,i)*gmatdn(j,j)
!c     2        -gmatup(j,i)*gmatup(i,j) - gmatdn(j,i)*gmatdn(i,j))
!c            spinxx(kx,ky,kz) = spinxx(kx,ky,kz) + xxtemp
!c            spinzz(kx,ky,kz) = spinzz(kx,ky,kz) + zztemp
!c210     continue
!c        ke = (kex*tx+key*ty+kez*tz) / toff

!       BEGIN  ==================================================================
        do ispecies=1,Nspecies
            n_species(ispecies) = n_species(ispecies)/toff
            ke(ispecies) = (kex(ispecies)*tx + key(ispecies)*ty
     1       + kez(ispecies)*tz)/toff
        end do

        do ispecies=1,Nspecies-1
            do jspecies=ispecies+1,Nspecies
                nud(ispecies,jspecies) = nud(ispecies,jspecies)/toff
            end do
        end do

        do 41 kx = 0, nx/2
            if(kx .eq. 0 .or. kx .eq. nx/2)then
                xfac = 1
            else
                xfac = 2
            endif
            do 41 ky = 0, ny/2
                if(ky .eq. 0 .or. ky .eq. ny/2)then
                    yfac = 1
                else
                    yfac = 2
                endif
                do 41 kz = 0, 0
                    if(kz .eq. 0 .or. kz .eq. 0)then
                        zfac = 1
                    else
                        zfac = 2
                    endif
                    do ispecies=1,Nspecies
                        do jspecies=1,Nspecies
                    spinab(kx,ky,kz,ispecies,jspecies) = spinab(kx,ky,
     1               kz,ispecies,jspecies)/(toff*xfac*yfac*zfac)
                        end do
                    end do
41      continue

!       END ====================================================================


!c        do 41 kx = 0, nx/2
!c          if(kx .eq. 0 .or. kx .eq. nx/2)then
!c            xfac = 1
!c          else
!c            xfac = 2
!c          endif
!c          do 41 ky = 0, ny/2
!c            if(ky .eq. 0 .or. ky .eq. ny/2)then
!c              yfac = 1
!c            else
!c              yfac = 2
!c            endif
!c          do 41 kz = 0, 0
!c            if(kz .eq. 0 .or. kz .eq. 0)then
!c              zfac = 1
!c            else
!c              zfac = 2
!c            endif
!c            spinxx(kx,ky,kz) = spinxx(kx,ky,kz) / (toff*xfac*yfac*zfac)
!c            spinzz(kx,ky,kz) = spinzz(kx,ky,kz) / (toff*xfac*yfac*zfac)
!c            grfun(kx,ky,kz) = grfun(kx,ky,kz) / (2*toff*xfac*yfac*zfac)
!c            den(kx,ky,kz,0) = den(kx,ky,kz,0) / (2*toff*xfac*yfac*zfac)
!c            den(kx,ky,kz,1) = den(kx,ky,kz,1) / (toff*xfac*yfac*zfac)
!c41      continue

! See note above:
!c        den(0,0,0,0) = (nup + ndn) * 0.5d0

        nmeas0 = nmeas0 +1
        sgntot = PRODUCT(sgn)

        do ispecies=1,Nspecies
            an(ispecies) = an(ispecies) + n_species(ispecies)*sgntot
        end do

        do ispecies=1,Nspecies-1
            do jspecies=ispecies+1,Nspecies
                anud(ispecies,jspecies) = anud(ispecies,jspecies)
     1           + nud(ispecies,jspecies)*sgntot
            end do
        end do

        do ispecies=1,Nspecies
            ake(ispecies) = ake(ispecies) + ke(ispecies)*sgntot
        end do

        asgn = asgn + sgntot

        do ispecies=1,Nspecies
            asgn_species(ispecies) = asgn_species(ispecies)
     1       + sgn(ispecies)
        end do

        do kx=0,nx/2
            do ky=0,ny/2
                do kz=0,0
                    do ispecies=1,Nspecies
                        do jspecies=1,Nspecies
                    aspinab(kx,ky,kz,ispecies,jspecies) = aspinab(kx,ky,
     1               kz,ispecies,jspecies) + spinab(kx,ky,kz,ispecies,
     2               jspecies)*sgntot
!       There is something funky happening here
!                    aspinzz(kx,ky,kz)=aspinzz(kx,ky,kz)+(Nspecies+1.d0-
!     1               2.d0*ispecies)*(Nspecies+1.d0 - 2.d0*jspecies)*
!     2              aspinab(kx,ky,kz,ispecies,jspecies)
                        end do
                    end do
                end do
            end do
        end do

!c        do 51 kx = 0, nx/2
!c          do 51 ky = 0, ny/2
!c          do 51 kz = 0, 0
!c            agrfun(kx,ky,kz) = agrfun(kx,ky,kz)
!c     1                        + grfun(kx,ky,kz)*sgn
!c            aden(kx,ky,kz,0) = aden(kx,ky,kz,0)
!c     1                        + den(kx,ky,kz,0)*sgn
!c            aden(kx,ky,kz,1) = aden(kx,ky,kz,1)
!c     1                        + den(kx,ky,kz,1)*sgn
!c            aspinxx(kx,ky,kz) = aspinxx(kx,ky,kz)
!c     1                        + spinxx(kx,ky,kz)*sgn
!c51          aspinzz(kx,ky,kz) = aspinzz(kx,ky,kz)
!c     1                        + spinzz(kx,ky,kz)*sgn

        return
        end

!*******************************meastau******************************
! 		We are ignoring this subroutine. Not interested in time-dependent
!		measurements at the moment.

!*******************************zeroas*******************************

        subroutine zeroas()
        implicit none
        integer nx,ny,nz,l,Nspecies,volume,toff
        parameter(nx=4,ny=4,nz=1,l=10,Nspecies=6)
        parameter(volume=nx*ny*nz*l,toff=nx*ny*nz)

!       BEGIN ==================================================================
        real*8 sgn(Nspecies)
        real*8 n_species(Nspecies)
        real*8 nud(Nspecies,Nspecies)
        real*8 ke(Nspecies)
        real*8 sgntot
!        real*8 sgnup,sgndn,sgn,nup,ndn,nud,ke
!       END ====================================================================

!       BEGIN ==================================================================
        real*8 asgn_species(Nspecies),asgn,an(Nspecies)
        real*8 anud(Nspecies,Nspecies)
        real*8 ake(Nspecies)
!       END ====================================================================
        real*8 grfun(0:nx/2,0:ny/2,0:0)
        real*8 spinxx(0:nx/2,0:ny/2,0:0)
        real*8 spinzz(0:nx/2,0:ny/2,0:0)
        integer nmeas0,redo,noredo
        !real*8 asgnup,asgndn,asgn,anup,andn,anud,ake
        real*8 agrfun(0:nx/2,0:ny/2,0:0)
        real*8 aspinxx(0:nx/2,0:ny/2,0:0)
        real*8 aspinzz(0:nx/2,0:ny/2,0:0)
        real*8 den(0:nx/2,0:ny/2,0:0,0:1)
        real*8 aden(0:nx/2,0:ny/2,0:0,0:1)
        real*8 errrat
        integer ispecies,jspecies

!       BEGIN ==================================================================
        real*8 spinab(0:nx/2,0:ny/2,0:0,Nspecies,Nspecies)
        real*8 aspinab(0:nx/2,0:ny/2,0:0,Nspecies,Nspecies)
!       END ====================================================================

        common/m0var/ sgntot,
     1       grfun,spinxx,spinzz,aspinxx,aspinzz,
     2       asgn,den,aden,agrfun,errrat,spinab,aspinab

        common/m0vects/ sgn,n_species,asgn_species,an,nud,ke,anud,ake

        common/m0vari/nmeas0,redo,noredo

        integer nmeast
        real*8 gnl(0:nx/2,0:ny/2,0:0,0:l)
        real*8 agnl(0:nx/2,0:ny/2,0:0,0:l),asgnt
        real*8 chinl(0:nx/2,0:ny/2,0:0,0:l)
        real*8 achinl(0:nx/2,0:ny/2,0:0,0:l)
        common/mtauvar/gnl,agnl,chinl,achinl,asgnt,nmeast

        integer i,j,ti,k

        nmeas0 = 0
        nmeast = 0
        call setto0(anud,asgn_species,an,ake,asgn,asgnt)
!        call setto0(asgnup,asgndn,asgn,anup,andn)
!        call setto0(anud,ake,asgnt,asgnup,asgndn)
        do 10 i = 0, nx/2
            do 10 j = 0, ny/2
                do 10 k = 0, 0
                    agrfun(i,j,k) = 0.d0
                    aspinxx(i,j,k) = 0.d0
                    aspinzz(i,j,k) = 0.d0
                    aden(i,j,k,0) = 0.d0
                    aden(i,j,k,1) = 0.d0
                    do ispecies=1,Nspecies
                        do jspecies=1,Nspecies
                            aspinab(i,j,k,ispecies,jspecies) = 0.d0
                        end do
                    end do
                    do 10 ti = 0, l
                        agnl(i,j,k,ti) = 0.d0
                        achinl(i,j,k,ti) = 0.d0
10      continue

        return
        end

!*******************************setto0*******************************

        subroutine setto0(a,b,c,d,e,f)
        implicit none
        integer Nspecies
        parameter(Nspecies=6)
        real*8 a(Nspecies,Nspecies)
        real*8 b(Nspecies),c(Nspecies),d(Nspecies)
        real*8 e,f
        integer ispecies,jspecies

        do ispecies=1,Nspecies-1
            do jspecies=ispecies+1,Nspecies
                a(ispecies,jspecies) =0.d0
            end do
        end do

        do ispecies=1,Nspecies
           b(ispecies) = 0.d0
           c(ispecies) = 0.d0
           d(ispecies) = 0.d0
        end do
        e = 0.d0
        f = 0.d0
        return
        end

!        subroutine setto0(a,b,c,d,e)
!        real*8 a,b,c,d,e
!        a=0.d0
!        b=0.d0
!        c=0.d0
!        d=0.d0
!        e=0.d0
!        return
!        end

!*******************************ftltow********************************
! Fourier transform g(n,l) to get g(n,w) (Fermi frequencies).

        subroutine ftltow(gl,gw,ndimx,ndimy,ndimz,maxl,dtau,bose,nmax)
        implicit none
        real*8 twopi
        parameter(twopi=6.283185307179586d0)
        integer ndimx,ndimy,ndimz,maxl,bose,nmax
        real*8 gl(0:ndimx/2,0:ndimy/2,0:ndimz/2,0:maxl),dtau
        real*8 omega
        real*8 larray(1000),terpray(1000),tauray(1000)
        real*8 temp,temp2,temp3,rti2
        complex*16 gw(0:ndimx/2,0:ndimy/2,0:ndimz/2,0:maxl)
        integer ti,ti2,intrat,mx,my,mz
        parameter (intrat=4)
!       dtau/intrat is the spacing used for the tau integration.

        do 20 mx = 0, ndimx/2
            do 20 my = 0, ndimy/2
                do 20 mz = 0, ndimz/2
                    do 10 ti = 0, maxl
                        larray(ti+1) = gl(mx,my,mz,ti)
10                      tauray(ti+1) = ti*dtau
                    call spline(tauray,larray,maxl+1,2d30,2d30,terpray)
!       Fourier transform over time to get g(n,w).
                    do 20 ti = 0, nmax
                        if(bose .eq. 0)then
                            omega = (ti+0.5d0)*twopi/dfloat(maxl)
                        else
                            omega = ti*twopi/dfloat(maxl)
                        endif
            call splint(tauray,larray,terpray,maxl+1,0.d0,temp)
            call splint(tauray,larray,terpray,maxl+1,maxl*dtau,temp2)
            rti2 = (intrat*maxl-1.d0)/intrat*dtau
            call splint(tauray,larray,terpray,maxl+1,rti2,temp3)
            gw(mx,my,mz,ti) = temp*dtau / intrat / 3.d0
     1       + temp2*exp(cmplx(0.0,1.0)*omega*maxl)*dtau/intrat/3.d0
     2       + temp3*exp(cmplx(0.0,1.0)*omega*rti2/dtau)*
     3                                 dtau/intrat*(4.d0/3.d0)
            do 20 ti2 = 1,intrat*maxl-3,2
                call splint(tauray,larray,terpray,maxl+1,
     1                                     ti2*dtau/intrat,temp)
           gw(mx,my,mz,ti) = gw(mx,my,mz,ti) + temp*(4.d0/3.d0) *
     1        exp(cmplx(0.d0,1.d0)*omega*ti2/intrat)*dtau/intrat
                call splint(tauray,larray,terpray,maxl+1,
     1                                (ti2+1)*dtau/intrat,temp)
           gw(mx,my,mz,ti) = gw(mx,my,mz,ti) + temp*(2.d0/3.d0) *
     1       exp(cmplx(0.0,1.0)*omega*(ti2+1)/intrat)*dtau/intrat
20      continue
        return
        end

!******************************ftntok*********************************
! Fourier transform g(n,l) to get g(q,l).

        subroutine ftntok(gn,gq,ndimx,ndimy,ndimz,maxl)
        implicit none
        real*8 twopi
        parameter(twopi=6.283185307179586d0)
        integer ndimx,ndimy,ndimz,maxl
        real*8 gn(0:ndimx/2,0:ndimy/2,0:ndimz/2,0:maxl)
        real*8 gq(0:ndimx/2,0:ndimy/2,0:ndimz/2,0:maxl),cfac
        real*8 csx(0:400),csy(0:400),csz(0:400)
        integer mx,my,lx,ly,ti,lxp,lyp,first
        integer mz,lz,lzp

        if(first .ne. 1273) then
            if(ndimx.gt.20.or.ndimy.gt.20.or.ndimz.gt.20)
     1       write(76,*)'Help#1 in ftntok!,',ndimx,ndimy,ndimz
            first = 1273
            do 100 lx = 0,ndimx**2
100             csx(lx) = cos(twopi/ndimx*lx)
            do 102 ly = 0,ndimy**2
102             csy(ly) = cos(twopi/ndimy*ly)
            do 104 lz = 0,ndimz**2
104             csz(lz) = cos(twopi/ndimz*lz)
        endif
        do 10 mx = 0, ndimx/2
            do 10 my = 0, ndimy/2
                do 10 mz = 0, ndimz/2
                    do 15 ti = 0, maxl
15                      gq(mx,my,mz,ti) = 0.d0
                do 10 lx = 0, ndimx-1
                    lxp = min(lx,ndimx-lx)
                    do 10 ly = 0, ndimy-1
                        lyp = min(ly,ndimy-ly)
                        do 10 lz = 0, ndimz-1
                            lzp = min(lz,ndimz-lz)
                            cfac = csx(mx*lx) * csy(my*ly) * csz(mz*lz)
                            do 10 ti = 0, maxl
                                gq(mx,my,mz,ti) = gq(mx,my,mz,ti)+
     1                           cfac * gn(lxp,lyp,lzp,ti)
10      continue
        return
        end

!*****************************spline**********************************
! Function spline

        SUBROUTINE SPLINE(X,Y,N,YP1,YPN,Y2)
        PARAMETER (NMAX=400)
        implicit real*8(a-h,o-z)
        REAL*8 X(N),Y(N),Y2(N),U(NMAX)
!       DIMENSION X(N),Y(N),Y2(N),U(NMAX)
        IF (YP1.GT..99E30) THEN
            Y2(1)=0.d0
            U(1)=0.d0
        ELSE
            Y2(1)=-0.5d0
            U(1)=(3.d0/(X(2)-X(1)))*((Y(2)-Y(1))/(X(2)-X(1))-YP1)
        ENDIF
        DO 10 I=2,N-1
            SIG=(X(I)-X(I-1))/(X(I+1)-X(I-1))
            P=SIG*Y2(I-1)+2.d0
            Y2(I)=(SIG-1.d0)/P
            U(I)=(6.d0*((Y(I+1)-Y(I))/(X(I+1)-X(I))-(Y(I)-Y(I-1))
     *         /(X(I)-X(I-1)))/(X(I+1)-X(I-1))-SIG*U(I-1))/P
10      continue
        IF (YPN.GT..99E30) THEN
            QN=0.d0
            UN=0.d0
        ELSE
            QN=0.5d0
            UN=(3.d0/(X(N)-X(N-1)))*(YPN-(Y(N)-Y(N-1))/(X(N)-X(N-1)))
        ENDIF
        Y2(N)=(UN-QN*U(N-1))/(QN*Y2(N-1)+1.d0)
        DO 20 K=N-1,1,-1
            Y2(K)=Y2(K)*Y2(K+1)+U(K)
20      continue
        RETURN
        END

!*****************************splint**********************************
! Function splint

        SUBROUTINE SPLINT(XA,YA,Y2A,N,X,Y)
        implicit real*8(a-h,o-z)
        REAL*8 XA(N),YA(N),Y2A(N),X,Y
!       DIMENSION XA(N),YA(N),Y2A(N)
        KLO=1
        KHI=N
1       IF (KHI-KLO.GT.1) THEN
            K=(KHI+KLO)/2
            IF(XA(K).GT.X)THEN
                KHI=K
            ELSE
                KLO=K
            ENDIF
        GOTO 1
        ENDIF
        H=XA(KHI)-XA(KLO)
        IF (H.EQ.0.) then
            write(6,*) 'Bad XA input.'
            stop
        endif
        A=(XA(KHI)-X)/H
        B=(X-XA(KLO))/H
        Y=A*YA(KLO)+B*YA(KHI)+
     *     ((A**3-A)*Y2A(KLO)+(B**3-B)*Y2A(KHI))*(H**2)/6.d0
        RETURN
        END

!**************************INVERTR(BBB,BBBIN,D,IDET,IPVT)**********************
!       This subroutine finds the inverse of the matrix b
!       using Gaussian elimination with partial pivoting.
!       b is the input matrix.
!       c is the inverse of b.
!       d is the determinent of b.
!       toff is the size of the matrix
!       If idet=0 the inverse of b is returned but not the determinent.
!       If idet=1 the determinent is returned,but not the inverse.
!       If idet=2 both the inverse and the determinent are returned.

        subroutine invertr(b,c,d,lnd,dim,toff,idet,ipvt)

        implicit none
        integer dim,toff,ipvt(dim)
        real*8 b(dim,dim),c(dim,dim),d,tb,lnd
        integer iwn,nm1,k,kp1,mb,i,j,idet,kb,km1

        ipvt(toff)=1
        iwn=1
        nm1=toff-1

!       Finding the pivot

        do 35 k=1,nm1
            kp1=k+1
            mb=k
            do 15 i=kp1,toff
                if (dabs(b(i,k)).gt.dabs(b(mb,k))) mb=i
15      continue
        ipvt(k)=mb
        tb=b(mb,k)
        if (mb.ne.k) then
            ipvt(toff)=-ipvt(toff)
            b(mb,k)=b(k,k)
            b(k,k)=tb
        endif
        if (dabs(tb).lt.1.d-10) then
            iwn=0
            go to 35
        endif

!       Computing multipliers

        do 20 i=kp1,toff
20          b(i,k)=-b(i,k)/tb

!       Interchange and elimination by columns

        do 30 j=kp1,toff
            tb=b(mb,j)
            if (mb.ne.k) then
                b(mb,j)=b(k,j)
                b(k,j)=tb
            endif
        do 25 i=kp1,toff
25          b(i,j)=b(i,j)+b(i,k)*tb
cray       call saxpy(toff-k,tb,b(kp1,k),1,b(kp1,j),1)
30      continue
35      continue
        if (iwn.eq.0) then
        write (6,*) 'Warning: Pivot=0'
        d=0.d0
        go to 150
        endif
        if (idet.gt.0) then

!       Compute the determinent

        d=ipvt(toff)
        lnd=0.d0
        do 40 i=1,toff
            lnd=lnd+dlog(dabs(b(i,i)))
40          d=d*b(i,i)
        endif
        if (idet.ne.1) then

!       Compute the inverse
!       Ax=b goes to A~x=Lb~

        do 50 i=1,toff
        do 45 j=1,toff
45          c(i,j)=0.d0
50          c(i,i)=1.d0
        do 100 j=1,toff
        do 60 k=1,nm1
            kp1=k+1
            mb=ipvt(k)
            tb=c(mb,j)
            if (mb.ne.k) then
                c(mb,j)=c(k,j)
                c(k,j)=tb
            endif
        do 55 i=kp1,toff
55          c(i,j)=c(i,j)+b(i,k)*tb
cray       call saxpy(toff-k,tb,b(kp1,k),1,c(kp1,j),1)
60      continue

!       Inverting A~

        do 70 kb=1,nm1
        km1=toff-kb
        k=km1+1
        c(k,j)=c(k,j)/b(k,k)
        tb=-c(k,j)
        do 65 i=1,km1
65          c(i,j)=c(i,j)+b(i,k)*tb
cray       call saxpy(km1,tb,b(1,k),1,c(1,j),1)
70      continue
        c(1,j)=c(1,j)/b(1,1)
100     continue
        endif
150     continue
        return
        end


!       USE THESE COMMENTED OUT LINES IF REAL*8 DESIRED.
        REAL*8 FUNCTION RAN2(IDUM)
        IMPLICIT REAL*8(A-H,O-Z)
!       FUNCTION RAN2(IDUM)
        save
        PARAMETER (M=714025,IA=1366,IC=150889,RM=1.4005112d-6)
        DIMENSION IR(97)
        DATA IFF /0/
        IF(IDUM.LT.0.OR.IFF.EQ.0)THEN
            IFF=1
            IDUM=MOD(IC-IDUM,M)
            DO 11 J=1,97
                IDUM=MOD(IA*IDUM+IC,M)
                IR(J)=IDUM
11          CONTINUE
            IDUM=MOD(IA*IDUM+IC,M)
            IY=IDUM
        ENDIF
        J=1+(97*IY)/M
        IF(J.GT.97.OR.J.LT.1)PAUSE
        IY=IR(J)
        RAN2=IY*RM
        IDUM=MOD(IA*IDUM+IC,M)
        IR(J)=IDUM
        RETURN
        END

